package com.delfines.business;

import java.sql.CallableStatement;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;

import com.delfines.Constante;
import com.delfines.Empresa;
import com.delfines.dao.ConnectionFactory;
import com.delfines.vo.Cliente;
import com.delfines.vo.ListaPrecio;
import com.delfines.vo.Servicio;
import com.delfines.vo.Usuario;

public class ListaPrecioBo {
	
	public List<ListaPrecio> listaListaPrecio(){
		List<ListaPrecio> lista = new ArrayList<ListaPrecio>(); 
		
		PreparedStatement ps=null;
		ResultSet rs=null;

        try {
        	Connection conn = ConnectionFactory.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("SELECT id_lista_precio,denominacion,descripcion FROM dbo.lista_precio WHERE estado='"+Constante.ESTADO_ACTIVO+"' ");
            
            ps = conn.prepareStatement(query.toString());
            
            rs = ps.executeQuery();
            
            while(rs.next()){
            	ListaPrecio obj=new ListaPrecio();
            	obj.setIdListaPrecio(rs.getInt("id_lista_precio"));
            	obj.setDenominacion(rs.getString("denominacion"));
            	obj.setDescripcion(rs.getString("descripcion"));
            	lista.add(obj);
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return lista;
	}
	
	public Integer eliminarListaPrecio(Integer idListaPrecio,Usuario pUsuario){
		PreparedStatement ps=null;
		ResultSet rs=null;
		Integer res=0;
        try {
        	Connection conn = ConnectionFactory.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("UPDATE dbo.lista_precio ");
            query.append("SET estado = ? ");
            query.append(",audit_usuarioid = ? ");
            query.append(",audit_fechahora = getdate() ");
            query.append(",audit_terminal = ? ");
            query.append("WHERE id_lista_precio=? ");
            
            ps = conn.prepareStatement(query.toString());
            ps.setInt(1, Constante.ESTADO_ELIMINADO);
            ps.setInt(2, pUsuario.getUsuarioId());
            ps.setString(3, Constante.TERMINAL);
            ps.setInt(4, idListaPrecio);
            //--
            res=ps.executeUpdate();
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } catch (Exception e) {
            throw new RuntimeException(e);
        }finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        return res;
	}
	
	
	
	/**
	 * 
	 * @param idTipoCliente
	 * @param idTipoDocumento
	 * @param denominacion
	 * @param nrodocumento
	 * @param telefono
	 * @param direccion
	 * @param pUsuario
	 * @return
	 */
	public Integer registraCliente(Integer idTipoCliente,Integer idTipoDocumento,String denominacion,
			   String nrodocumento,String telefono,String direccion,Usuario pUsuario){
		PreparedStatement ps=null;
		ResultSet rs=null;
		Integer pk=0;
        try {
        	Connection conn = ConnectionFactory.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("INSERT INTO dbo.cliente(id_tipo_cliente,id_tipo_documento,nro_documento,denominacion ");
            query.append(",telefono,direccion,estado ");
            query.append(",audit_usuarioid,audit_fechahora,audit_terminal,audit_estado,id_empresa) ");
            query.append("VALUES ");
            query.append("(?,?,?,? ");
            query.append(",?,?,? ");
            query.append(",?,getdate(),?,1,?) ");
            
            String ids[] = new String[] { "id_cliente" };
            
            ps = conn.prepareStatement(query.toString(),ids);
            ps.setInt(1, idTipoCliente);
            ps.setInt(2, idTipoDocumento);
            ps.setString(3, nrodocumento);
	        ps.setString(4, denominacion);
	            ps.setString(5, telefono);
	            ps.setString(6, direccion);
	            ps.setInt(7, Constante.ESTADO_ACTIVO);
            ps.setInt(8, pUsuario.getUsuarioId());
            ps.setString(9, Constante.TERMINAL);
            ps.setInt(10, Empresa.getInstance().ID_EMPRESA);
            //--
            if(ps.executeUpdate()>0){
            	rs = ps.getGeneratedKeys();
                if ( rs.next() ) {
                    pk = rs.getInt(1);
                }
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } catch (Exception e) {
            throw new RuntimeException(e);
        }finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return pk;
	}
	
	
	public Integer actualizaCliente(Integer idCliente,Integer idTipoCliente,Integer idTipoDocumento,String denominacion,
			   String nrodocumento,String telefono,String direccion,Usuario pUsuario){
		PreparedStatement ps=null;
		ResultSet rs=null;
		Integer res=0;
        try {
        	Connection conn = ConnectionFactory.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("UPDATE dbo.cliente ");
            query.append("SET id_tipo_cliente = ? ");
            query.append(",id_tipo_documento = ? ");
            query.append(",nro_documento = ? ");
            query.append(",denominacion = ? ");
	            query.append(",telefono = ? ");
	            query.append(",direccion = ? ");
            query.append(",audit_usuarioid = ? ");
            query.append(",audit_fechahora = getdate() ");
            query.append(",audit_terminal = ? ");
            query.append(",id_empresa = ? ");
            query.append("WHERE id_cliente=? ");
            query.append("AND id_empresa=").append(Empresa.getInstance().ID_EMPRESA).append(" ");//-- FILTRO POR EMPRESA
            
            ps = conn.prepareStatement(query.toString());
            ps.setInt(1, idTipoCliente);
            ps.setInt(2, idTipoDocumento);
            ps.setString(3, nrodocumento);
	        ps.setString(4, denominacion);
	            ps.setString(5, telefono);
	            ps.setString(6, direccion);
            ps.setInt(7, pUsuario.getUsuarioId());
            ps.setString(8, Constante.TERMINAL);
            ps.setInt(9, idCliente);
            //--
            res=ps.executeUpdate();
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } catch (Exception e) {
            throw new RuntimeException(e);
        }finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return res;
	}
	
	public List<Servicio> listarServicio(Integer idListaPrecio){
		List<Servicio> lista = new ArrayList<Servicio>(); 
		
		PreparedStatement ps=null;
		ResultSet rs=null;

        try {
        	Connection conn = ConnectionFactory.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("SELECT d.id_lista_precio,s.id_servicio,s.denominacion,s.descripcion,ISNULL(d.precio_unitario,0) precio_unitario,ISNULL(d.cantidad_stock,0) cantidad_stock,ISNULL(d.subtotal_stock,0) subtotal_stock,d.id_detalle_lista,s.marca FROM dbo.servicio s ");
            query.append("inner join dbo.detalle_lista d ON (s.id_servicio=d.id_servicio) ");
            query.append("WHERE s.estado='"+Constante.ESTADO_ACTIVO+"' and d.estado='"+Constante.ESTADO_ACTIVO+"' ");
            query.append("AND d.id_lista_precio=? ");
            query.append("AND s.id_empresa=").append(Empresa.getInstance().ID_EMPRESA).append(" ");//-- FILTRO POR EMPRESA
            query.append("ORDER BY s.id_servicio ASC");
		
            ps = conn.prepareStatement(query.toString());
            ps.setInt(1, idListaPrecio);
            
            rs = ps.executeQuery();
            
            while(rs.next()){
            	Servicio obj=new Servicio();
            	obj.setIdServicio(rs.getInt("id_servicio"));//------
            	obj.setDenominacion(rs.getString("denominacion"));
            	obj.setDescripcion(rs.getString("descripcion"));
            	obj.setPrecioUnitario(rs.getDouble("precio_unitario"));
            	obj.setCantidadStock(rs.getDouble("cantidad_stock"));
            	obj.setSubtotalStock(rs.getDouble("subtotal_stock"));
            	obj.setIdDetalleLista(rs.getInt("id_detalle_lista"));//------
            	//--
            	obj.setIdListaPrecio(rs.getInt("id_lista_precio"));//------
            	obj.setMarca(rs.getString("marca"));
            	lista.add(obj);
            }
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return lista;
	}
	
	public Integer registraListaPrecio(String denominacion,String descripcion,String fechaInicio,String fechaFin,Usuario pUsuario){
		PreparedStatement ps=null;
		ResultSet rs=null;
		Integer pk=0;
        try {
        	Connection conn = ConnectionFactory.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("INSERT INTO dbo.lista_precio(denominacion,descripcion,fecha_inicio,fecha_fin,estado, ");
            query.append("audit_usuarioid,audit_fechahora,audit_terminal,audit_estado) ");
            query.append("VALUES (?,?,?,?,?, ");
            query.append("?,GETDATE(),?,1) ");
            
            String ids[] = new String[] { "id_lista_precio" };
            
            ps = conn.prepareStatement(query.toString(),ids);
            ps.setString(1, denominacion);
            ps.setString(2, descripcion);
            
            if(fechaInicio!=null&&fechaInicio.trim().length()>0){
            	ps.setDate(3, Util.stringToDate(fechaInicio));	
            }else{
            	ps.setNull(3, java.sql.Types.DATE);
            }
            
            if(fechaFin!=null&&fechaFin.trim().length()>0){
            	ps.setDate(4, Util.stringToDate(fechaFin));	
            }else{
            	ps.setNull(4, java.sql.Types.DATE);
            }
            
            ps.setInt(5, Constante.ESTADO_ACTIVO);
            ps.setInt(6, pUsuario.getUsuarioId());
            ps.setString(7, Constante.TERMINAL);
            //--
            if(ps.executeUpdate()>0){
            	rs = ps.getGeneratedKeys();
                if ( rs.next() ) {
                    pk = rs.getInt(1);
                }
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } catch (Exception e) {
            throw new RuntimeException(e);
        }finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return pk;
	}
	
	public Integer actualizaListaPrecio(Integer idListaPrecio,String denominacion,String descripcion,String fechaInicio,String fechaFin,Usuario pUsuario){
		PreparedStatement ps=null;
		ResultSet rs=null;
		Integer result=0;
        try {
        	Connection conn = ConnectionFactory.getInstance().getConnection();
            
        	StringBuilder query = new StringBuilder();
            query.append("UPDATE dbo.lista_precio ");
            query.append("SET denominacion = ? ");
            query.append(",descripcion = ? ");
            query.append(",fecha_inicio = ? ");
            query.append(",fecha_fin = ? ");
            query.append(",estado = ? ");
            query.append(",audit_usuarioid = ? ");
            query.append(",audit_fechahora = getdate() ");
            query.append(",audit_terminal = ? ");
            query.append("WHERE id_lista_precio=? ");
            
            ps = conn.prepareStatement(query.toString());
            ps.setString(1, denominacion);
            ps.setString(2, descripcion);
            
            if(fechaInicio!=null&&fechaInicio.trim().length()>0){
            	ps.setDate(3, Util.stringToDate(fechaInicio));	
            }else{
            	ps.setNull(3, java.sql.Types.DATE);
            }
            
            if(fechaFin!=null&&fechaFin.trim().length()>0){
            	ps.setDate(4, Util.stringToDate(fechaFin));	
            }else{
            	ps.setNull(4, java.sql.Types.DATE);
            }
            
            ps.setInt(5, Constante.ESTADO_ACTIVO);
            ps.setInt(6, pUsuario.getUsuarioId());
            ps.setString(7, Constante.TERMINAL);
            ps.setInt(8, idListaPrecio);
            //--
            result=ps.executeUpdate();
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } catch (Exception e) {
            throw new RuntimeException(e);
        }finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return result;
	}
	
	public Integer actualizaPrecioUnitario(Integer idListaPrecio,Integer idServicio,Integer idDetalleLista,Double precioUnitario,Double cantidadStock,Usuario pUsuario){
		PreparedStatement ps=null;
		ResultSet rs=null;
		Integer result=0;
        try {
        	Connection conn = ConnectionFactory.getInstance().getConnection();
            
        	StringBuilder query = new StringBuilder();
            query.append("UPDATE dbo.detalle_lista ");
            query.append("SET precio_unitario = ? ");
            query.append(",cantidad_stock = ? ");
            query.append(",subtotal_stock = ? ");
            query.append(",audit_usuarioid = ? ");
            query.append(",audit_fechahora = getdate() ");
            query.append(",audit_terminal = ? ");
            query.append("WHERE id_servicio=? ");
            query.append("AND id_lista_precio=? ");
            query.append("AND id_detalle_lista=? ");
            
            ps = conn.prepareStatement(query.toString());
            ps.setDouble(1, precioUnitario);
            ps.setDouble(2, cantidadStock);
            ps.setDouble(3, precioUnitario*cantidadStock);
            ps.setInt(4, pUsuario.getUsuarioId());
            ps.setString(5, Constante.TERMINAL);
            ps.setInt(6, idServicio);
            ps.setInt(7, idListaPrecio);
            ps.setInt(8, idDetalleLista);
            //--
            result=ps.executeUpdate();
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } catch (Exception e) {
            throw new RuntimeException(e);
        }finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return result;
	}
	
	public Integer crearMovimientoEntrada(Integer idListaPrecio,Integer idDetalleLista,Usuario pUsuario){
		CallableStatement cs = null;
		Integer pk=Constante.ID_INICIAL;
        try {
        	Connection conn = ConnectionFactory.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("{ call dbo.crear_movimiento_desde_detalle_lista(?,?,?,?) }");
            
            cs = conn.prepareCall(query.toString());
            cs.setInt(1, idListaPrecio);
            cs.setInt(2, idDetalleLista);
            cs.setInt(3, pUsuario.getUsuarioId());
            cs.registerOutParameter(4, java.sql.Types.INTEGER);  
            //--
            cs.execute();
            pk=cs.getInt(4);
            System.out.println("ID_MOVIMIENTO: " + pk);  
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (cs != null) {try {cs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return pk;
	}
	
	public Integer insertaPrecioUnitario(Integer idListaPrecio,Integer idServicio,Double precioUnitario,Double cantidadStock,Usuario pUsuario){
		PreparedStatement ps=null;
		ResultSet rs=null;
		Integer pk=0;
        try {
        	Connection conn = ConnectionFactory.getInstance().getConnection();
            
        	StringBuilder query = new StringBuilder();
            query.append("INSERT INTO dbo.detalle_lista(id_lista_precio,id_servicio,precio_unitario,cantidad_stock,subtotal_stock,estado,audit_usuarioid,audit_fechahora,audit_terminal,audit_estado) ");
            query.append("VALUES(?,?,?,?,?,1,?,getdate(),null,'1') ");
            
            String ids[] = new String[] { "id_detalle_lista" };
            
            ps = conn.prepareStatement(query.toString(),ids);
            ps.setInt(1, idListaPrecio);
            ps.setInt(2, idServicio);
            ps.setDouble(3,precioUnitario);
            ps.setDouble(4,cantidadStock);
            ps.setDouble(5,precioUnitario*cantidadStock);
            ps.setInt(6, pUsuario.getUsuarioId());
            
            //--
            if(ps.executeUpdate()>0){
            	rs = ps.getGeneratedKeys();
                if ( rs.next() ) {
                    pk = rs.getInt(1);
                }
            }
            
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } catch (Exception e) {
            throw new RuntimeException(e);
        }finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return pk;
	}
	
	
	public Integer insertarServicioDetalleLista(Integer idListaPrecio,Usuario pUsuario){
		
		PreparedStatement ps=null;
		ResultSet rs=null;
		Integer result=0;
        try {
        	Connection conn = ConnectionFactory.getInstance().getConnection();
            
        	StringBuilder query = new StringBuilder();
            query.append("INSERT INTO dbo.detalle_lista ");
            query.append("(id_lista_precio,id_servicio,precio_unitario,estado ");
            query.append(",audit_usuarioid,audit_fechahora,audit_terminal,audit_estado) ");
            query.append("SELECT ?,s.id_servicio,0,?, ");
            query.append("?,getdate(),?,'1' FROM dbo.servicio s WHERE estado='1' ");
            query.append("AND s.id_empresa=").append(Empresa.getInstance().ID_EMPRESA).append(" ");//-- FILTRO POR EMPRESA
            
            ps = conn.prepareStatement(query.toString());
            ps.setInt(1, idListaPrecio);
            ps.setInt(2, Constante.ESTADO_ACTIVO);
            ps.setInt(3, pUsuario.getUsuarioId());
            ps.setString(4, Constante.TERMINAL);
            //--
            result=ps.executeUpdate();
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } catch (Exception e) {
            throw new RuntimeException(e);
        }finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return result;
		
		
	}
	
	
	public ListaPrecio obtenerListaPrecioById(Integer idListaPrecio){
		ListaPrecio obj=null; 
		
		PreparedStatement ps=null;
		ResultSet rs=null;

        try {
        	Connection conn = ConnectionFactory.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("SELECT id_lista_precio,denominacion,descripcion,convert(varchar(20),fecha_inicio,103) fecha_inicio,convert(varchar(20),fecha_fin,103) fecha_fin "); 
            query.append("FROM dbo.lista_precio WHERE id_lista_precio=?");
            
            ps = conn.prepareStatement(query.toString());
            ps.setInt(1, idListaPrecio);
            
            rs = ps.executeQuery();
            
            if(rs.next()){
            	obj=new ListaPrecio();
            	obj.setIdListaPrecio(rs.getInt("id_lista_precio"));
            	obj.setDenominacion(rs.getString("denominacion"));
            	obj.setDescripcion(rs.getString("descripcion"));
            	obj.setFechaInicio(rs.getString("fecha_inicio"));
            	obj.setFechaFin(rs.getString("fecha_fin"));
            }
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return obj;
	}
	

}
