package com.delfines.business;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.LinkedList;
import java.util.List;

import com.delfines.Empresa;
import com.delfines.dao.ConnectionFactory;
import com.delfines.dao.ConnectionFactoryOperaBat;
import com.delfines.vo.Cliente;
import com.delfines.vo.MPAnuncio;
import com.delfines.vo.MPCaracteristica;
import com.delfines.vo.OpSalesDetail;
import com.delfines.vo.OpSalesHeader;
import com.delfines.vo.Value;

public class MPBusinessBo {
	
	public List<MPCaracteristica> listCaracteristica(){
		List<MPCaracteristica> lista = new ArrayList<MPCaracteristica>(); 
		
		PreparedStatement ps=null;
		ResultSet rs=null;

        try {
        	Connection conn = ConnectionFactory.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("SELECT id_caracteristica,denominacion,tipo,seleccion FROM dbo.mp_caracteristica WHERE estado=1 ORDER BY secuencia ASC ");
            
            ps = conn.prepareStatement(query.toString());
            rs = ps.executeQuery();
            
            while(rs.next()){
            	MPCaracteristica obj=new MPCaracteristica();
            	obj.setId(rs.getInt("id_caracteristica"));
            	obj.setDenominacion(rs.getString("denominacion"));
            	obj.setTipo(rs.getString("tipo"));
            	obj.setSeleccion(rs.getString("seleccion"));
            	
            	List<Value> l=new LinkedList<>();
            	l=listDetalleCaracteristica(obj.getId());
            	obj.setLista(l);
            	
            	lista.add(obj);
            }
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        return lista;
	}
	
	public List<Value> listDetalleCaracteristica(Integer idCaracteristica){
		List<Value> lista = new ArrayList<Value>(); 
		
		PreparedStatement ps=null;
		ResultSet rs=null;

        try {
        	Connection conn = ConnectionFactory.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("SELECT id_detalle_caracteristica,denominacion FROM dbo.mp_detalle_caracteristica WHERE id_caracteristica=? AND estado=1 ORDER BY secuencia ASC");
            
            ps = conn.prepareStatement(query.toString());
            ps.setInt(1, idCaracteristica);
            
            rs = ps.executeQuery();
            
            while(rs.next()){
            	Value obj=new Value();
            	obj.setId(rs.getInt("id_detalle_caracteristica"));
            	obj.setDenominacion(rs.getString("denominacion"));
            	lista.add(obj);
            }
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        return lista;
	}
	
	public List<MPAnuncio> listAnuncios(String listIdDetalleCaracteristica){
		List<MPAnuncio> lista = new ArrayList<MPAnuncio>(); 
		
		PreparedStatement ps=null;
		ResultSet rs=null;

        try {
        	Connection conn = ConnectionFactory.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("SELECT id_anuncio,titulo,descripcion,video,direccion,anunciante,whatsapp,facebook,precio,fecha FROM dbo.mp_anuncio WHERE estado=1 AND id_anuncio IN ( ");
            query.append("SELECT id_anuncio FROM dbo.mp_anuncio_caracteristica WHERE id_detalle_caracteristica IN (").append(listIdDetalleCaracteristica).append(") ");
            query.append(") ORDER BY fecha DESC ");
            
            ps = conn.prepareStatement(query.toString());
            rs = ps.executeQuery();
            
            while(rs.next()){
            	MPAnuncio obj=new MPAnuncio();
            	obj.setId(rs.getInt("id_anuncio"));
            	obj.setTitulo(rs.getString("titulo"));
            	obj.setDescripcion(rs.getString("descripcion"));
            	obj.setVideo(rs.getString("video"));
            	obj.setDireccion(rs.getString("direccion"));
            	obj.setAnunciante(rs.getString("anunciante"));
            	obj.setWhatsapp(rs.getString("whatsapp"));
            	obj.setFacebook(rs.getString("facebook"));
            	obj.setPrecio(rs.getString("precio"));
            	obj.setFecha(rs.getString("fecha"));
            	lista.add(obj);
            }
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        return lista;
	}
	
	
}