package com.delfines.business;

import java.sql.CallableStatement;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import com.delfines.Constante;
import com.delfines.dao.ConnectionFactory;
import com.delfines.vo.ErrorLead;
import com.delfines.vo.GuiaDetalle;
import com.delfines.vo.Lead;
import com.delfines.vo.LeadSeguimiento;
import com.delfines.vo.Usuario;
import com.delfines.vo.Value;

public class RegistroLeadsBo {
	
	public Integer loadLeads(String filePath){
		CallableStatement cs = null;
		Integer errors=Constante.ID_INICIAL;
        try {
        	Connection conn = ConnectionFactory.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("{ call dbo.load_leads_from_csv(?) }");
            
            cs = conn.prepareCall(query.toString());
            cs.registerOutParameter(1, java.sql.Types.INTEGER);  
            //--
            cs.execute();
            errors=cs.getInt(1);
            System.out.println("ID_COMPROBANTE: " + errors);  
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (cs != null) {try {cs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return errors;
	}
	
	public List<ErrorLead> listLeadsErrors(){
		List<ErrorLead> lista = new ArrayList<ErrorLead>(); 
		
		PreparedStatement ps=null;
		ResultSet rs=null;

        try {
        	Connection conn = ConnectionFactory.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("SELECT e.ERROR_NUMBER, ");
            query.append("e.ERROR_MESSAGE, ");
            query.append("e.ERROR_DATE, ");
            query.append("e.id_adset_name_1, ");
            query.append("e.dia_adset_2, ");
            query.append("e.mes_adset_3, ");
            query.append("e.anyo_adset_4, ");
            query.append("e.pax_adulto_5, ");
            query.append("e.pax_ninyo_6, ");
            query.append("e.lead_7, ");
            query.append("e.nombre_cliente_8, ");
            query.append("e.email_cliente_9, ");
            query.append("e.telefono_cliente_10, ");
            query.append("e.precio_pax_adulto_11, ");
            query.append("e.precio_total_12, ");
            query.append("e.area_13, ");
            query.append("e.sub_area_14, ");
            query.append("e.dia_envio_15, ");
            query.append("e.mes_envio_16, ");
            query.append("e.anyo_envio_17 ");
            query.append("FROM dbo.ERROR_LEAD e ");
		
            ps = conn.prepareStatement(query.toString());
            rs = ps.executeQuery();
            
            while(rs.next()){
            	ErrorLead obj=new ErrorLead();
            	obj.setERROR_NUMBER(rs.getString("ERROR_NUMBER"));
            	obj.setERROR_MESSAGE(rs.getString("ERROR_MESSAGE"));
            	obj.setERROR_DATE(rs.getString("ERROR_DATE"));
            	obj.setId_adset_name_1(rs.getString("id_adset_name_1"));
            	obj.setDia_adset_2(rs.getString("dia_adset_2"));
            	obj.setMes_adset_3(rs.getString("mes_adset_3"));
            	obj.setAnyo_adset_4(rs.getString("anyo_adset_4"));
            	obj.setPax_adulto_5(rs.getString("pax_adulto_5"));
            	obj.setPax_ninyo_6(rs.getString("pax_ninyo_6"));
            	obj.setLead_7(rs.getString("lead_7"));
            	obj.setNombre_cliente_8(rs.getString("nombre_cliente_8"));
            	obj.setEmail_cliente_9(rs.getString("email_cliente_9"));
            	obj.setTelefono_cliente_10(rs.getString("telefono_cliente_10"));
            	obj.setPrecio_pax_adulto_11(rs.getString("precio_pax_adulto_11"));
            	obj.setPrecio_total_12(rs.getString("precio_total_12"));
            	obj.setArea_13(rs.getString("area_13"));
            	obj.setSub_area_14(rs.getString("sub_area_14"));
            	obj.setDia_envio_15(rs.getString("dia_envio_15"));
            	obj.setMes_envio_16(rs.getString("mes_envio_16"));
            	obj.setAnyo_envio_17(rs.getString("anyo_envio_17"));
            	lista.add(obj);
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return lista;
	}
	
	public List<Lead> listLeadsByIdAdSetName(Integer idAdSetName,Usuario pUser){
		List<Lead> lista = new ArrayList<Lead>(); 
		
		PreparedStatement ps=null;
		ResultSet rs=null;

        try {
        	Connection conn = ConnectionFactory.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("select l.id_lead,a.denominacion adsetname,convert(varchar(20),l.fecha_adset,103) fecha_adset,l.pax_adulto,l.pax_ninyo,l.lead,l.nombre_cliente, "); 
            query.append("l.email_cliente,l.telefono_cliente,l.precio_pax_adulto,l.precio_pax_ninyo,l.precio_total,r.denominacion area,s.denominacion sub_area, "); 
            query.append("l.id_area,l.id_sub_area ");
            query.append(",e.denominacion ejecutivo ");
            query.append(",e.id_ejecutiva ");
            query.append(",(SELECT count(1) FROM dbo.lead_seguimiento s where s.id_lead=l.id_lead) seguimiento ");
            query.append("from dbo.lead l  ");
            query.append("inner join dbo.adset_name a on (l.id_adset_name=a.id_adset_name) "); 
            query.append("inner join dbo.area r on (r.id_area=l.id_area)  ");
            query.append("inner join dbo.sub_area s on (s.id_sub_area=l.id_sub_area) ");
            query.append("left  join dbo.ejecutiva e on (e.id_ejecutiva=l.id_ejecutiva) ");
            query.append("where l.id_adset_name=?  ");
            query.append(sqlWherefromProfile(pUser.getIdPerfilLead(), pUser.getAreaId(), pUser.getUsuarioId()));
			query.append("ORDER BY l.id_lead ");
			
            ps = conn.prepareStatement(query.toString());
            ps.setInt(1, idAdSetName);
            rs = ps.executeQuery();
            
            while(rs.next()){
            	Lead obj=new Lead();
            	obj.setIdLead(rs.getInt("id_lead"));
            	obj.setAdSetName(rs.getString("adsetname"));
            	obj.setFechaAdSet(rs.getString("fecha_adset"));
            	obj.setPaxAdulto(rs.getInt("pax_adulto"));
            	obj.setPaxNinyo(rs.getInt("pax_ninyo"));
            	obj.setLead(rs.getInt("lead"));
            	obj.setNombreCliente(rs.getString("nombre_cliente"));
            	obj.setEmailCliente(rs.getString("email_cliente"));
            	obj.setTelefonoCliente(rs.getString("telefono_cliente"));
            	obj.setPrecioPaxAdulto(rs.getDouble("precio_pax_adulto"));
            	obj.setPrecioPaxNinyo(rs.getDouble("precio_pax_ninyo"));
            	obj.setPrecioTotal(rs.getDouble("precio_total"));
            	obj.setArea(rs.getString("area"));
            	obj.setIdArea(rs.getInt("id_area"));
            	obj.setSubArea(rs.getString("sub_area"));
            	obj.setIdSubArea(rs.getInt("id_sub_area"));
            	obj.setEjecutivo(rs.getString("ejecutivo"));
            	obj.setIdEjecutivo(rs.getInt("id_ejecutiva"));
            	obj.setSeguimiento(rs.getInt("seguimiento"));
            	lista.add(obj);
            }
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return lista;
	}
	
	
	public List<Lead> listLeadsByFechaAdSet(String fechaIni,String fechaFin,Usuario pUser){
		List<Lead> lista = new ArrayList<Lead>(); 
		
		PreparedStatement ps=null;
		ResultSet rs=null;

        try {
        	Connection conn = ConnectionFactory.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("select l.id_lead,a.denominacion adsetname,convert(varchar(20),l.fecha_adset,103) fecha_adset,l.pax_adulto,l.pax_ninyo,l.lead,l.nombre_cliente, "); 
            query.append("l.email_cliente,l.telefono_cliente,l.precio_pax_adulto,l.precio_pax_ninyo,l.precio_total,r.denominacion area,s.denominacion sub_area, "); 
            query.append("l.id_area,l.id_sub_area "); 
            query.append(",e.denominacion ejecutivo ");
            query.append(",e.id_ejecutiva ");
            query.append(",(SELECT count(1) FROM dbo.lead_seguimiento s where s.id_lead=l.id_lead) seguimiento ");
            query.append("from dbo.lead l  ");
            query.append("inner join dbo.adset_name a on (l.id_adset_name=a.id_adset_name) "); 
            query.append("inner join dbo.area r on (r.id_area=l.id_area)  ");
            query.append("inner join dbo.sub_area s on (s.id_sub_area=l.id_sub_area) "); 
            query.append("left join dbo.ejecutiva e on (e.id_ejecutiva=l.id_ejecutiva) ");
            query.append("where l.fecha_carga between ? and ? ");
            query.append(sqlWherefromProfile(pUser.getIdPerfilLead(), pUser.getAreaId(), pUser.getUsuarioId()));
			query.append("ORDER BY l.id_lead ");
			
            ps = conn.prepareStatement(query.toString());
            ps.setDate(1, Util.stringToDate(fechaIni));
            ps.setDate(2, Util.stringToDate(fechaFin));
            
            rs = ps.executeQuery();
            
            while(rs.next()){
            	Lead obj=new Lead();
            	obj.setIdLead(rs.getInt("id_lead"));
            	obj.setAdSetName(rs.getString("adsetname"));
            	obj.setFechaAdSet(rs.getString("fecha_adset"));
            	obj.setPaxAdulto(rs.getInt("pax_adulto"));
            	obj.setPaxNinyo(rs.getInt("pax_ninyo"));
            	obj.setLead(rs.getInt("lead"));
            	obj.setNombreCliente(rs.getString("nombre_cliente"));
            	obj.setEmailCliente(rs.getString("email_cliente"));
            	obj.setTelefonoCliente(rs.getString("telefono_cliente"));
            	obj.setPrecioPaxAdulto(rs.getDouble("precio_pax_adulto"));
            	obj.setPrecioPaxNinyo(rs.getDouble("precio_pax_ninyo"));
            	obj.setPrecioTotal(rs.getDouble("precio_total"));
            	obj.setArea(rs.getString("area"));
            	obj.setIdArea(rs.getInt("id_area"));
            	obj.setSubArea(rs.getString("sub_area"));
            	obj.setIdSubArea(rs.getInt("id_sub_area"));
            	obj.setEjecutivo(rs.getString("ejecutivo"));
            	obj.setIdEjecutivo(rs.getInt("id_ejecutiva"));
            	obj.setSeguimiento(rs.getInt("seguimiento"));
            	lista.add(obj);
            }
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return lista;
	}
	
	public List<Lead> listLeadsByIdArea(Integer idArea,Integer idSubArea,Usuario pUser){
		List<Lead> lista = new ArrayList<Lead>(); 
		
		PreparedStatement ps=null;
		ResultSet rs=null;

        try {
        	Connection conn = ConnectionFactory.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("select l.id_lead,a.denominacion adsetname,convert(varchar(20),l.fecha_adset,103) fecha_adset,l.pax_adulto,l.pax_ninyo,l.lead,l.nombre_cliente, "); 
            query.append("l.email_cliente,l.telefono_cliente,l.precio_pax_adulto,l.precio_pax_ninyo,l.precio_total,r.denominacion area,s.denominacion sub_area, "); 
            query.append("l.id_area,l.id_sub_area "); 
            query.append(",e.denominacion ejecutivo ");
            query.append(",e.id_ejecutiva ");
            query.append(",(SELECT count(1) FROM dbo.lead_seguimiento s where s.id_lead=l.id_lead) seguimiento ");
            query.append("from dbo.lead l  ");
            query.append("inner join dbo.adset_name a on (l.id_adset_name=a.id_adset_name) "); 
            query.append("inner join dbo.area r on (r.id_area=l.id_area)  ");
            query.append("inner join dbo.sub_area s on (s.id_sub_area=l.id_sub_area) "); 
            query.append("left  join dbo.ejecutiva e on (e.id_ejecutiva=l.id_ejecutiva) ");
            query.append("where l.id_area=? and l.id_sub_area=? ");
            query.append(sqlWherefromProfile(pUser.getIdPerfilLead(), pUser.getAreaId(), pUser.getUsuarioId()));
			query.append("ORDER BY l.id_lead ");
			
            ps = conn.prepareStatement(query.toString());
            ps.setInt(1, idArea);
            ps.setInt(2, idSubArea);
            
            rs = ps.executeQuery();
            
            while(rs.next()){
            	Lead obj=new Lead();
            	obj.setIdLead(rs.getInt("id_lead"));
            	obj.setAdSetName(rs.getString("adsetname"));
            	obj.setFechaAdSet(rs.getString("fecha_adset"));
            	obj.setPaxAdulto(rs.getInt("pax_adulto"));
            	obj.setPaxNinyo(rs.getInt("pax_ninyo"));
            	obj.setLead(rs.getInt("lead"));
            	obj.setNombreCliente(rs.getString("nombre_cliente"));
            	obj.setEmailCliente(rs.getString("email_cliente"));
            	obj.setTelefonoCliente(rs.getString("telefono_cliente"));
            	obj.setPrecioPaxAdulto(rs.getDouble("precio_pax_adulto"));
            	obj.setPrecioPaxNinyo(rs.getDouble("precio_pax_ninyo"));
            	obj.setPrecioTotal(rs.getDouble("precio_total"));
            	obj.setArea(rs.getString("area"));
            	obj.setIdArea(rs.getInt("id_area"));
            	obj.setSubArea(rs.getString("sub_area"));
            	obj.setIdSubArea(rs.getInt("id_sub_area"));
            	obj.setEjecutivo(rs.getString("ejecutivo"));
            	obj.setIdEjecutivo(rs.getInt("id_ejecutiva"));
            	obj.setSeguimiento(rs.getInt("seguimiento"));
            	lista.add(obj);
            }
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return lista;
	}
	
	public List<LeadSeguimiento> listLeadsSeguimientoByIdLead(Integer idLead){
		List<LeadSeguimiento> lista = new ArrayList<LeadSeguimiento>(); 
		
		PreparedStatement ps=null;
		ResultSet rs=null;

        try {
        	Connection conn = ConnectionFactory.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("SELECT id_lead_seguimiento ");
            query.append(",(case when id_cotizado=1 then 'SI' ELSE 'NO' END) cotizado ");
            query.append(",convert(varchar(20),fecha_contacto,103) fecha_contacto ");
            query.append(",(case when id_canal=1 then 'CORREO' WHEN id_canal=2 THEN 'LLAMADA' WHEN id_canal=3 THEN 'PRESENCIAL'  ELSE 'NINGUNO' END) canal ");
            query.append(",(case when id_canal=1 then 'SI' ELSE 'NO' END) reserva ");
            query.append(",(CASE  ");
            query.append("WHEN id_motivo=1 then 'NO CONTESTA' ");
            query.append("WHEN id_motivo=2 then 'NO ESTA INTERESADO' ");
            query.append("WHEN id_motivo=3 then 'POR CONFIRMAR' ");
            query.append("WHEN id_motivo=4 then 'NUMERO INVALIDO' ");
            query.append("WHEN id_motivo=5 then 'VOLVER A CONTACTAR' ");
            query.append("WHEN id_motivo=6 then 'TOMO OTRA OPCION' ");
            query.append("ELSE 'NINGUNO' ");
            query.append("END) motivo ");
            query.append(",pax_final ");
            query.append(",revenue ");
            query.append(",servicio_final ");
            query.append(",id_usuario ");
            query.append(",id_lead ");
            query.append(",e.denominacion ejecutivo ");
            query.append("FROM Lead.dbo.lead_seguimiento s ");
            query.append("inner join dbo.ejecutiva e on (e.id_ejecutiva=s.id_usuario) ");
            query.append("where id_lead=? ORDER BY id_lead_seguimiento ASC  ");
			
            ps = conn.prepareStatement(query.toString());
            ps.setInt(1, idLead);
            
            
            rs = ps.executeQuery();
            
            while(rs.next()){
            	LeadSeguimiento obj=new LeadSeguimiento();
            	obj.setIdLead(rs.getInt("id_lead"));
            	obj.setIdLeadSeguimiento(rs.getInt("id_lead_seguimiento"));
            	obj.setCotizado(rs.getString("cotizado"));
            	obj.setFechaContacto(rs.getString("fecha_contacto"));
            	obj.setCanal(rs.getString("canal"));
            	obj.setReserva(rs.getString("reserva"));
            	obj.setMotivo(rs.getString("motivo"));
            	obj.setPaxFinal(rs.getString("pax_final"));
            	obj.setRevenue(rs.getString("revenue"));
            	obj.setServicioFinal(rs.getString("servicio_final"));
            	obj.setIdUsuario(rs.getInt("id_usuario"));
            	obj.setIdLead(rs.getInt("id_lead"));
            	obj.setEjecutivo(rs.getString("ejecutivo"));
            	lista.add(obj);
            }
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return lista;
	}
	
	
	public List<Value> listAdSetName(){
		List<Value> lista = new ArrayList<Value>(); 
		
		PreparedStatement ps=null;
		ResultSet rs=null;

        try {
        	Connection conn = ConnectionFactory.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("select id_adset_name id, denominacion from dbo.adset_name where estado='1'  order by denominacion asc ");
		
            ps = conn.prepareStatement(query.toString());
            rs = ps.executeQuery();
            
            while(rs.next()){
            	Value obj=new Value();
            	obj.setId(rs.getInt("id"));
            	obj.setDenominacion(rs.getString("denominacion"));
            	lista.add(obj);
            }
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return lista;
	}
	public List<Value> listArea(){
		List<Value> lista = new ArrayList<Value>(); 
		
		PreparedStatement ps=null;
		ResultSet rs=null;

        try {
        	Connection conn = ConnectionFactory.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("select id_area id, denominacion from dbo.area where estado='1' order by denominacion asc ");
		
            ps = conn.prepareStatement(query.toString());
            rs = ps.executeQuery();
            
            while(rs.next()){
            	Value obj=new Value();
            	obj.setId(rs.getInt("id"));
            	obj.setDenominacion(rs.getString("denominacion"));
            	lista.add(obj);
            }
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return lista;
	}
	
	public List<Value> listSubArea(){
		List<Value> lista = new ArrayList<Value>(); 
		
		PreparedStatement ps=null;
		ResultSet rs=null;

        try {
        	Connection conn = ConnectionFactory.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("select id_sub_area id, denominacion from dbo.sub_area where estado='1' order by denominacion asc");
		
            ps = conn.prepareStatement(query.toString());
            rs = ps.executeQuery();
            
            while(rs.next()){
            	Value obj=new Value();
            	obj.setId(rs.getInt("id"));
            	obj.setDenominacion(rs.getString("denominacion"));
            	lista.add(obj);
            }
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return lista;
	}

	public List<Value> listEjecutivo(){
		List<Value> lista = new ArrayList<Value>(); 
		
		PreparedStatement ps=null;
		ResultSet rs=null;

        try {
        	Connection conn = ConnectionFactory.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("SELECT e.id_ejecutiva id,e.denominacion FROM dbo.ejecutiva e where e.estado='1' order by e.denominacion asc");
		
            ps = conn.prepareStatement(query.toString());
            rs = ps.executeQuery();
            
            while(rs.next()){
            	Value obj=new Value();
            	obj.setId(rs.getInt("id"));
            	obj.setDenominacion(rs.getString("denominacion"));
            	lista.add(obj);
            }
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return lista;
	}
	
	public String sqlWherefromProfile(Integer idLeadPerfil,Integer idArea,Integer idUsuario){
		StringBuilder sqlWhere = new StringBuilder();
		
		if(idLeadPerfil==1){
			sqlWhere.append(" AND 1=1 ");
		}else if(idLeadPerfil==2){
			sqlWhere.append(" AND 1=1 ");	
			//sqlWhere.append(" AND l.id_area=").append(String.valueOf(idArea)).append(" AND l.id_ejecutiva=").append(String.valueOf(idUsuario));
		}
		
		return sqlWhere.toString();
	}
	
	
	public Integer reAsignarEjecutivo(Integer idEjecutivo,Integer idLead){
		PreparedStatement ps=null;
		ResultSet rs=null;
		Integer result=0;
        try {
        	Connection conn = ConnectionFactory.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("UPDATE dbo.lead SET id_ejecutiva = ? WHERE id_lead =? ");
            
            ps = conn.prepareStatement(query.toString());
            ps.setInt(1, idEjecutivo);
            ps.setInt(2, idLead);
            //--
            result=ps.executeUpdate();
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } catch (Exception e) {
            throw new RuntimeException(e);
        }finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return result;
	}
	
	
	public Integer asignarEjecutivo(Integer idEjecutivo,List<Lead> listaLeads){
		PreparedStatement ps=null;
		ResultSet rs=null;
		Integer result=0;
        try {
        	Connection conn = ConnectionFactory.getInstance().getConnection();
            
        	String Ids=getIdLeads(listaLeads);
        	
            StringBuilder query = new StringBuilder();
            query.append("UPDATE dbo.lead SET id_ejecutiva = ? WHERE id_lead IN ("+Ids+") AND isnull(id_ejecutiva,0)=0 ");
            
            ps = conn.prepareStatement(query.toString());
            ps.setInt(1, idEjecutivo);
            //--
            result=ps.executeUpdate();
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } catch (Exception e) {
            throw new RuntimeException(e);
        }finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return result;
	}
	
	public String getIdLeads(List<Lead> listaLeads){
		StringBuilder ids = new StringBuilder();
        
		for (Iterator<Lead> it = listaLeads.iterator(); it.hasNext(); ) {
		    if (it.hasNext()) {
		    	ids.append(it.next().getIdLead());
		    	ids.append(",");
		    }
		}
		ids.append("0");
		
		return ids.toString();
	}
	
	public Integer guardarSeguimiento(Integer idEjecutivo,Integer idLead,Integer idCotizado,String fechaContacto,Integer idCanal,
			Integer idReserva,Integer idMotivo,String paxFinal,String revenue,String servicioFinal,Usuario pUser){
		Integer result=Constante.ID_INICIAL;
		
		PreparedStatement ps=null;
		ResultSet rs=null;
		Integer pk=0;
        try {
        	Connection conn = ConnectionFactory.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("INSERT INTO dbo.lead_seguimiento(id_cotizado,fecha_contacto,id_canal,id_reserva,id_motivo,pax_final,revenue,servicio_final,id_usuario,id_lead) ");
            query.append("VALUES(?,?,?,?,?,?,?,?,?,?) ");
            
            ps = conn.prepareStatement(query.toString());
            ps.setInt(1, idCotizado);
            ps.setDate(2, Util.stringToDate(fechaContacto));
            ps.setInt(3, idCanal);
            ps.setInt(4, idReserva);
            ps.setInt(5, idMotivo);
            ps.setString(6, paxFinal);
            ps.setString(7, revenue);
            ps.setString(8, servicioFinal);
            ps.setInt(9, idEjecutivo);
            ps.setInt(10, idLead);
            //--
            if(ps.executeUpdate()>0){
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } catch (Exception e) {
            throw new RuntimeException(e);
        }finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
		return result;
	}

	public String getDate(){
		String fecha=""; 
		
		PreparedStatement ps=null;
		ResultSet rs=null;

        try {
        	Connection conn = ConnectionFactory.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("SELECT convert(varchar(20),getdate(),103) hoy ");
            ps = conn.prepareStatement(query.toString());
            
            rs = ps.executeQuery();
            
            if(rs.next()){
            	fecha=rs.getString("hoy");
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return fecha;
	}
	
	
}
