package com.delfines.business;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.LinkedList;
import java.util.List;

import com.delfines.Empresa;
import com.delfines.dao.ConnectionFactoryOperaBat;
import com.delfines.vo.Cliente;
import com.delfines.vo.OpSalesDetail;
import com.delfines.vo.OpSalesHeader;

public class RegistroOperaBo {
	
	public List<OpSalesHeader> listaComprobante(String fechaComprobante){
		OpSalesHeader obj = null; 
		PreparedStatement ps=null;
		ResultSet rs=null;

		List<OpSalesHeader> lista=new LinkedList<>();
        try {
        	Connection conn = ConnectionFactoryOperaBat.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("SELECT CSUBDIA, "); 
            query.append("CCOMPRO,  ");
            query.append("CFECCOM,  ");
            query.append("CCODMON,  ");
            query.append("CSITUA,  ");
            query.append("CTIPCAM,  ");//--DOUBLE
            query.append("CGLOSA,  ");
            query.append("CTOTAL,  ");//--DOUBLE
            query.append("CTIPO,  ");
            query.append("CFLAG,  ");
            query.append("TO_CHAR(CDATE,'DD/MM/RRRR') CDATE,  ");
            query.append("CHORA,  ");
            query.append("CFECCAM,  ");
            query.append("CUSER,  ");
            query.append("CORIG,  ");
            query.append("CFORM,  ");
            query.append("CTIPCOM,  ");
            query.append("NVL(CEXTOR,' ') CEXTOR,  ");
            query.append("FISCAL_BILL_NO, "); 
            query.append("BILL_NO,  ");
            query.append("RESV_NAME_ID,  ");
            query.append("FOLIO_NO,  ");
            query.append("SEQ_NO ");
            query.append("FROM TRAINING.HLD_OP_SALES_HEADER WHERE CFECCOM=to_char(TO_DATE(?,'DD/MM/RRRR'), 'RRMMDD') ");
            query.append("ORDER BY CCOMPRO ");
            
            ps = conn.prepareStatement(query.toString());
            ps.setString(1,fechaComprobante);
            rs = ps.executeQuery();
            
            while(rs.next()){
            	obj=new OpSalesHeader();
            	obj.setCSUBDIA(rs.getString("CSUBDIA"));
            	obj.setCCOMPRO(rs.getString("CCOMPRO"));
            	obj.setCFECCOM(rs.getString("CFECCOM"));
            	obj.setCCODMON(rs.getString("CCODMON"));
            	obj.setCSITUA(rs.getString("CSITUA"));
            	obj.setCTIPCAM(Util.formatDec(rs.getDouble("CTIPCAM")));//--DOUBLE
            	obj.setCGLOSA(rs.getString("CGLOSA"));
            	obj.setCTOTAL(Util.formatDec(rs.getDouble("CTOTAL")));//--DOUBLE
            	obj.setCTIPO(rs.getString("CTIPO"));
            	obj.setCFLAG(rs.getString("CFLAG"));
            	obj.setCDATE(rs.getString("CDATE"));
            	obj.setCHORA(rs.getString("CHORA"));
            	obj.setCFECCAM(rs.getString("CFECCAM"));
            	obj.setCUSER(rs.getString("CUSER"));
            	obj.setCORIG(rs.getString("CORIG"));
            	obj.setCFORM(rs.getString("CFORM"));
            	obj.setCTIPCOM(rs.getString("CTIPCOM"));
            	obj.setCEXTOR(rs.getString("CEXTOR"));
            	obj.setFISCAL_BILL_NO(rs.getString("FISCAL_BILL_NO")); 
            	obj.setBILL_NO(rs.getString("BILL_NO"));
            	obj.setRESV_NAME_ID(rs.getString("RESV_NAME_ID"));
            	obj.setFOLIO_NO(rs.getString("FOLIO_NO"));
            	obj.setSEQ_NO(rs.getString("SEQ_NO"));
                lista.add(obj);
            }
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        return lista;
	}
	
	
	public List<OpSalesDetail> obtenerComprobanteDetalleDBF(String fechaComprobante){
		List<OpSalesDetail> lista = new ArrayList<OpSalesDetail>(); 
		
		PreparedStatement ps=null;
		ResultSet rs=null;

        try {
        	Connection conn = ConnectionFactoryOperaBat.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("SELECT DSUBDIA, ");
            query.append("DCOMPRO, ");
            query.append("DSECUE, ");
            query.append("DFECCOM, ");
            query.append("DCUENTA, ");
            query.append("DCODANE, ");
            query.append("DCENCOS, ");
            query.append("DCODMON, ");
            query.append("DDH, ");
            query.append("DIMPORT, ");//--DOUBLE
            query.append("DTIPDOC, ");
            query.append("DNUMDOC, ");
            query.append("DFECDOC, ");
            query.append("DFECVEN, ");
            query.append("DAREA, ");
            query.append("DFLAG, ");
            query.append("DXGLOSA, ");
            query.append("TO_CHAR(DDATE,'DD/MM/RRRR') DDATE, ");
            query.append("DCODANE2, ");
            query.append("DUSIMPOR, ");//--DOUBLE
            query.append("DMNIMPOR, ");//--DOUBLE
            query.append("DCODARC, ");
            query.append("FLAGX, ");
            query.append("DMEDPAG, ");
            query.append("DIGVCOM, ");//--DOUBLE
            query.append("DTIDREF, ");
            query.append("DNDOREF, ");
            query.append("TO_CHAR(DFECREF,'DD/MM/RRRR') DFECREF, ");
            query.append("DBIMREF, ");//--DOUBLE
            query.append("DIGVREF, ");//--DOUBLE
            query.append("DMAQREF, ");
            query.append("FISCAL_BILL_NO, ");
            query.append("BILL_NO, ");
            query.append("RESV_NAME_ID, ");
            query.append("FOLIO_NO, ");
            query.append("SEQ_NO ");
            query.append("FROM TRAINING.HLD_OP_SALES_DETAIL WHERE DFECCOM=TO_CHAR(TO_DATE(?,'DD/MM/RRRR'), 'RRMMDD') ");
            query.append("ORDER BY DCOMPRO,DSECUE ");
            
            ps = conn.prepareStatement(query.toString());
            ps.setString(1,fechaComprobante);
            rs = ps.executeQuery();
            
            while(rs.next()){
            	OpSalesDetail obj=new OpSalesDetail();
            	
            	obj.setDSUBDIA(rs.getString("DSUBDIA")); 
            	obj.setDCOMPRO(rs.getString("DCOMPRO")); 
            	obj.setDSECUE(rs.getString("DSECUE")); 
            	obj.setDFECCOM(rs.getString("DFECCOM")); 
            	obj.setDCUENTA(rs.getString("DCUENTA")); 
            	obj.setDCODANE(rs.getString("DCODANE")); 
            	obj.setDCENCOS(rs.getString("DCENCOS")); 
            	obj.setDCODMON(rs.getString("DCODMON")); 
            	obj.setDDH(rs.getString("DDH")); 
            	obj.setDIMPORT(Util.formatDec(rs.getDouble("DIMPORT"))); //--DOUBLE
            	obj.setDTIPDOC(rs.getString("DTIPDOC")); 
            	obj.setDNUMDOC(rs.getString("DNUMDOC")); 
            	obj.setDFECDOC(rs.getString("DFECDOC")); 
            	obj.setDFECVEN(rs.getString("DFECVEN")); 
            	obj.setDAREA(rs.getString("DAREA")); 
            	obj.setDFLAG(rs.getString("DFLAG")); 
            	obj.setDXGLOSA(rs.getString("DXGLOSA")); 
            	obj.setDDATE(rs.getString("DDATE")); 
            	obj.setDCODANE2(rs.getString("DCODANE2")); 
            	obj.setDUSIMPOR(Util.formatDec(rs.getDouble("DUSIMPOR"))); //--DOUBLE
            	obj.setDMNIMPOR(Util.formatDec(rs.getDouble("DMNIMPOR"))); //--DOUBLE
            	obj.setDCODARC(rs.getString("DCODARC")); 
            	obj.setFLAGX(rs.getString("FLAGX")); 
            	obj.setDMEDPAG(rs.getString("DMEDPAG")); 
            	obj.setDIGVCOM(rs.getString("DIGVCOM")); 
            	obj.setDTIDREF(rs.getString("DTIDREF")); 
            	obj.setDNDOREF(rs.getString("DNDOREF")); 
            	obj.setDFECREF(rs.getString("DFECREF")); 
            	obj.setDBIMREF(Util.formatDec(rs.getDouble("DBIMREF"))); //--DOUBLE
            	obj.setDIGVREF(Util.formatDec(rs.getDouble("DIGVREF"))); //--DOUBLE
            	obj.setDMAQREF(rs.getString("DMAQREF")); 
            	obj.setFISCAL_BILL_NO(rs.getString("FISCAL_BILL_NO")); 
            	obj.setBILL_NO(rs.getString("BILL_NO")); 
            	obj.setRESV_NAME_ID(rs.getString("RESV_NAME_ID")); 
            	obj.setFOLIO_NO(rs.getString("FOLIO_NO")); 
            	obj.setSEQ_NO(rs.getString("SEQ_NO"));
            	
            	lista.add(obj);
            }
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        return lista;
	}
	
	public List<Cliente> listaCliente(String fechaComprobante){
		Cliente obj = null; 
		PreparedStatement ps=null;
		ResultSet rs=null;

		List<Cliente> lista=new LinkedList<>();
        try {
        	Connection conn = ConnectionFactoryOperaBat.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("SELECT c.nro_documento, ");
            query.append("c.denominacion, ");
            query.append("convert(varchar(20),f.fecha_comprobante,103) fecha_comprobante, ");
            query.append("(case when c.id_tipo_cliente=2 then 0 else 1 end) tipo_cliente ");
            query.append("FROM dbo.comprobante f  ");
            query.append("INNER JOIN dbo.cliente c ON (F.id_cliente=c.id_cliente)  ");
            query.append("WHERE convert(varchar(20),f.fecha_comprobante,103)=convert(varchar(20),?,103) and f.estado=2 ");//COMPLETADO
            query.append("AND c.id_empresa=").append(Empresa.getInstance().ID_EMPRESA).append(" ");//-- FILTRO POR EMPRESA
            query.append("AND f.id_empresa=").append(Empresa.getInstance().ID_EMPRESA).append(" ");//-- FILTRO POR EMPRESA
            
            ps = conn.prepareStatement(query.toString());
            ps.setString(1,fechaComprobante);
            rs = ps.executeQuery();
            
            while(rs.next()){
            	obj=new Cliente();
            	obj.setNroDocumento(rs.getString("nro_documento"));
            	obj.setDenominacion(rs.getString("denominacion"));
            	obj.setAdate(rs.getString("fecha_comprobante"));
            	obj.setAdocide(rs.getString("tipo_cliente"));
            	
                lista.add(obj);
            }
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        return lista;
	}
}