package com.delfines.business;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;

import com.delfines.Constante;
import com.delfines.Empresa;
import com.delfines.dao.ConnectionFactory;
import com.delfines.vo.Usuario;

public class UsuarioBo {
	
	public String getDate(){
		String fecha=""; 
		
		PreparedStatement ps=null;
		ResultSet rs=null;

        try {
        	Connection conn = ConnectionFactory.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("SELECT convert(varchar(20),getdate(),103) hoy ");
            ps = conn.prepareStatement(query.toString());
            
            rs = ps.executeQuery();
            
            if(rs.next()){
            	fecha=rs.getString("hoy");
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return fecha;
	}
	
	public Usuario loginUsuario(String username,String passwd){
		Usuario usuario = null; 
		
		PreparedStatement ps=null;
		ResultSet rs=null;

        try {
            
        	Connection conn = ConnectionFactory.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("SELECT u.id_usuario,u.apellidos_nombres,u.username,u.id_perfil,id_empresa FROM usuario u WHERE u.username=? and u.passwd=? ");
            ps = conn.prepareStatement(query.toString());
            ps.setString(1, username);
            ps.setString(2, passwd);
            
            rs = ps.executeQuery();
            
            while(rs.next()){
            	usuario = new Usuario();
            	
            	usuario.setUsuarioId(rs.getInt("id_usuario"));
            	usuario.setApellidosNombres(rs.getString("apellidos_nombres"));
            	usuario.setUsername(rs.getString("username"));
            	usuario.setPerfilId(rs.getInt("id_perfil"));
            	//--
            	usuario.setIdPerfilLead(1);
            	usuario.setAreaId(1);
            	usuario.setDenominacionArea("Ventas");
            	//--
            	usuario.setIdEmpresa(rs.getInt("id_empresa"));
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return usuario;
	}
	
	/**
	 * 
	 */
	public Integer validaUsername(String username){
		Integer result=Constante.ID_INICIAL; 
		
		PreparedStatement ps=null;
		ResultSet rs=null;

        try {
        	Connection conn = ConnectionFactory.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("SELECT count(1) cantidad FROM dbo.empresa WHERE rtrim(ltrim(login))=? and estado='1'");
            
            ps = conn.prepareStatement(query.toString());
            ps.setString(1, username.trim());
            rs = ps.executeQuery();
            
            if(rs.next()){
            	result=rs.getInt("cantidad");
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        return result;
	}
	
	public Integer registraEmpresa(String login,String email,String password){
		 PreparedStatement ps=null;
		 ResultSet rs=null;
		 Integer pk=0;
	     try {
	     	Connection conn = ConnectionFactory.getInstance().getConnection();
	         
	         StringBuilder query = new StringBuilder();
	         query.append("INSERT INTO dbo.empresa(login,email,password,estado,audit_fechahora)VALUES(?,?,?,1,getdate()) ");
	         
	         String ids[] = new String[] { "id_empresa" };
	         
	         ps = conn.prepareStatement(query.toString(),ids);
	         ps.setString(1, login);
		     ps.setString(2, email);
		     ps.setString(3, password);
	         //--
	         if(ps.executeUpdate()>0){
	         	rs = ps.getGeneratedKeys();
	             if ( rs.next() ) {
	                 pk = rs.getInt(1);
	             }
	         }
	         
	     } catch (SQLException e) {
	         throw new RuntimeException(e);
	     } catch (Exception e) {
	         throw new RuntimeException(e);
	     }finally {
	     	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
	         if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
	     }
	     
	     return pk;
	}
	
	public Integer registraUsuario(String login,String password,Integer idEmpresa){
		 PreparedStatement ps=null;
		 ResultSet rs=null;
		 Integer pk=0;
	     try {
	     	Connection conn = ConnectionFactory.getInstance().getConnection();
	         
	         StringBuilder query = new StringBuilder();
	         query.append("INSERT INTO dbo.usuario(apellidos_nombres,id_area,audit_usuarioid,audit_fechahora,audit_estado,username,passwd,id_perfil,id_empresa) ");
	         query.append("VALUES(?,1,1,getdate(),1,?,?,1,?) ");
	         
	         String ids[] = new String[] { "id_usuario" };
	         
	         ps = conn.prepareStatement(query.toString(),ids);
	         ps.setString(1, login);
		     ps.setString(2, login);
		     ps.setString(3, password);
		     ps.setInt(4, idEmpresa);
	         //--
	         if(ps.executeUpdate()>0){
	         	rs = ps.getGeneratedKeys();
	             if ( rs.next() ) {
	                 pk = rs.getInt(1);
	             }
	         }
	         
	     } catch (SQLException e) {
	         throw new RuntimeException(e);
	     } catch (Exception e) {
	         throw new RuntimeException(e);
	     }finally {
	     	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
	         if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
	     }
	     
	     return pk;
	}
	
	
}
