package com.delfines.spring.config;

import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.ComponentScan;
import org.springframework.context.annotation.Configuration;
import org.springframework.scheduling.annotation.EnableScheduling;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.web.multipart.commons.CommonsMultipartResolver;
import org.springframework.web.servlet.config.annotation.EnableWebMvc;
import org.springframework.web.servlet.config.annotation.ResourceHandlerRegistry;
import org.springframework.web.servlet.config.annotation.WebMvcConfigurerAdapter;
import org.springframework.web.servlet.view.InternalResourceViewResolver;
import org.springframework.web.servlet.view.JstlView;

import com.delfines.business.ClienteBo;
import com.delfines.spring.controller.CreateDBFConcar;

/**
 * @author imssbora
 */

@Configuration
@EnableWebMvc
@ComponentScan(basePackages = { "com.delfines" })
@EnableScheduling
public class WebConfig extends WebMvcConfigurerAdapter {

   @Bean
   public InternalResourceViewResolver resolver() {
      
	  InternalResourceViewResolver resolver = new InternalResourceViewResolver();
      resolver.setViewClass(JstlView.class);
      resolver.setPrefix("/WEB-INF/views/");
      resolver.setSuffix(".jsp");
      
      return resolver;
   }
   
   public void addResourceHandlers(ResourceHandlerRegistry registry) {
       registry.addResourceHandler("/resources/**").addResourceLocations("/resources/");
   }

   @Bean(name = "multipartResolver")
   public CommonsMultipartResolver createMultipartResolver() {
       CommonsMultipartResolver resolver=new CommonsMultipartResolver();
       resolver.setDefaultEncoding("utf-8");
       return resolver;
   }
   
   @Scheduled(cron = "0 0 21 * * *")
   public void scheduleTaskUsingCronExpression() {
    	try{
    		System.out.println("INICIA CREA BDF CONCAR");
    		
    		ClienteBo bo=new ClienteBo();
        	String fechaComp=bo.getDate();
        	
        	CreateDBFConcar concar=new CreateDBFConcar();
		    concar.create(fechaComp);
		    
		    System.out.println("FINALIZA CREA BDF CONCAR");
 	    }catch(Exception e){
 	    	e.printStackTrace();
 	    }
   }
   
}
