package com.delfines.spring.controller;

import java.io.File;
import java.io.FileInputStream;
import java.io.InputStream;
import java.io.InputStreamReader;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;
import org.xml.sax.InputSource;

import com.delfines.business.Util;
import com.delfines.vo.QRComprobante;
import com.google.zxing.BarcodeFormat;
import com.google.zxing.Writer;
import com.google.zxing.client.j2se.MatrixToImageWriter;
import com.google.zxing.common.BitMatrix;
import com.google.zxing.qrcode.QRCodeWriter;



public class CodeQRWrite {
	
	/*RUC | TIPO DE DOCUMENTO | SERIE | NUMERO | MTO TOTAL IGV | MTO
	 TOTAL DEL COMPROBANTE | FECHA DE EMISION | TIPO DE DOCUMENTO
	 ADQUIRENTE | NUMERO DE DOCUMENTO ADQUIRENTE |VALOR RESUMEN<ds:DigestValue>*/
	
	private QRComprobante comprobante;
	
	public CodeQRWrite(QRComprobante comprobante){
		this.comprobante=comprobante;
		try{
			this.comprobante.setValorResumen(getDigestValue());
		}catch(Exception e){
			this.comprobante.setValorResumen("");
			e.printStackTrace();
		}
	 }
	 
	 public String writeQRCode(String path){
		 String pathQRImage=null;
		try{
			
			StringBuilder string = new StringBuilder();
			string.append(comprobante.getRuc()).append("|");
			string.append(comprobante.getTipoDocumento()).append("|");
			string.append(comprobante.getSerie()).append("|");
			string.append(comprobante.getNumero()).append("|");
			string.append(comprobante.getMontoTotalIgv()).append("|");
			string.append(comprobante.getMontoTotalComprobante()).append("|");
			string.append(comprobante.getFechaEmision()).append("|");
			string.append(comprobante.getTipoDocumento()).append("|");
			string.append(comprobante.getTipoDocumentoAdquiriente()).append("|");
			string.append(comprobante.getNumeroDocumentoAdquiriente()).append("|");
			string.append(comprobante.getValorResumen()!=null?comprobante.getValorResumen():"").append("|");
			
			BitMatrix bitMatrix;
	 		Writer writer=new QRCodeWriter();
	 		bitMatrix=writer.encode(string.toString(), BarcodeFormat.QR_CODE, 600, 600);
	 		
	 		pathQRImage=path+String.valueOf(comprobante.getIdComprobante())+".png";
	 		
	 		MatrixToImageWriter.writeToFile(bitMatrix, "png", new File(pathQRImage));
	 		System.out.println("generado...."+pathQRImage);
	 		
	 	}catch(Exception e){
	 		e.printStackTrace();
	 	}
		return pathQRImage;
	 }
	 
	 public String getPathDigestValue(){
		 
		 StringBuilder string = new StringBuilder();
		 //string.append(Util.pathQRDigestValue);
		 string.append(comprobante.getAnioEmision()).append("\\");
		 string.append(comprobante.getMesEmision()).append("\\");
		 string.append(comprobante.getDiaEmision()).append("\\");
		 string.append(comprobante.getXmlName()).append(".xml");//string.append("03_B013_00007691_01").append(".xml");//string.append("01_F001_00001997_01").append(".xml");
		 				  
		 return string.toString();
	 }
	 
	 public String getDigestValue() throws Exception{
		 String digestValue="";
		 /*
         InputStream in = new FileInputStream(new File(getPathDigestValue()));
         InputSource is =new InputSource(new InputStreamReader(in));
         
         DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
         DocumentBuilder db = dbf.newDocumentBuilder();
         
         Document doc = db.parse(is);
         NodeList nodes = doc.getElementsByTagName("campoString");
         for (int i = 0; i < nodes.getLength(); i++) {
           Element element = (Element) nodes.item(i);
           if(element.getAttribute("name").equals("DigestValue")){
        	   digestValue=element.getTextContent();
        	   break;
           }
         }*/
         return digestValue;
	 }
	 
	 public QRComprobante getComprobante() {
			return comprobante;
	 }

	 public void setComprobante(QRComprobante comprobante) {
			this.comprobante = comprobante;
	 }
		
	 
}