package com.delfines.spring.controller;

import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.springframework.core.io.ByteArrayResource;
import org.springframework.core.io.InputStreamResource;
import org.springframework.http.HttpHeaders;
import org.springframework.http.MediaType;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;

/**
 * @author imssbora
 */
@Controller
@RequestMapping("/download")
public class FileDownloadController {

   @RequestMapping("/zip/{fileName:.+}")
   public void downloadPDFResource( HttpServletRequest request,
                                    HttpServletResponse response,
                                    @PathVariable("fileName") String fileName)
   {
       //If user is not authorized - he should be thrown out from here itself
        
       //Authorized user will download the file
       String dataDirectory = request.getServletContext().getRealPath("/WEB-INF/downloads/zip/");
       Path file = Paths.get(dataDirectory, fileName);
       if (Files.exists(file))
       {
           response.setContentType("application/zip");
           response.addHeader("Content-Disposition", "attachment; filename="+fileName);
           try
           {
               Files.copy(file, response.getOutputStream());
               response.getOutputStream().flush();
           }
           catch (IOException ex) {
               ex.printStackTrace();
           }
       }
   }
}