package com.delfines.spring.controller;

import java.util.List;

import javax.servlet.http.HttpServletRequest;

import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;

import com.delfines.business.ClienteBo;
import com.delfines.business.MPBusinessBo;
import com.delfines.business.ServicioBo;
import com.delfines.vo.Usuario;

/**
 * @author imssbora
 */
@Controller
public class InitController {
   
   @RequestMapping(path={"/"},method=RequestMethod.GET)
   public String sayHello(Model model,HttpServletRequest request) {
	   try{
		   request.getSession().removeAttribute("p_usuario");
		   
		   MPBusinessBo servicio=new MPBusinessBo();
		   List lCaracteristica=servicio.listCaracteristica();
		   model.addAttribute("lCaracteristica", lCaracteristica);
		   
		   List lAnuncios=servicio.listAnuncios("30,38");
		   model.addAttribute("lAnuncios", lAnuncios);
		   
	   }catch(Exception e){
		   e.printStackTrace();
	   }
       return "index";
   }
   
   @RequestMapping(path={"/gallery-single"},method=RequestMethod.GET)
   public String gallerySingle(Model model,HttpServletRequest request) {
	   try{
		   request.getSession().removeAttribute("p_usuario");
		   
	   }catch(Exception e){
		   e.printStackTrace();
	   }
       return "gallery-single";
   }
   
   @RequestMapping(path={"/registro-anuncio"},method=RequestMethod.GET)
   public String registroGuia(Model model,HttpServletRequest request) {
	    ClienteBo servicio=new ClienteBo();
	    List lCliente=servicio.listaClientesGuia();
	    List lListaPrecio=servicio.listaListaPrecio();
	    List lPrioridad=servicio.listaPrioridad();
	    //--
	    ServicioBo serv=new ServicioBo(); 
	    List lServicios=serv.listaServiciosGuia();
	    
	    model.addAttribute("listaClientes", lCliente);
	    model.addAttribute("listaListaPrecio", lListaPrecio);
	    model.addAttribute("listaPrioridad", lPrioridad);
	    model.addAttribute("listaServicios", lServicios);
		   
	    return "registro-anuncio";
   }
   

//   @RequestMapping(path={"/login"},method=RequestMethod.GET)
//   public String login(Model model,HttpServletRequest request) {
//	   request.getSession().removeAttribute("p_usuario");
//	   return "login";
//   }
//
//   @RequestMapping(path={"/carga"},method=RequestMethod.GET)
//   public String  carga(Model model,HttpServletRequest request) {
//	   Usuario pUsuario=(Usuario)request.getSession().getAttribute("p_usuario");
//	   if(pUsuario!=null&&pUsuario.getUsuarioId()>0){
//		   return "upload";
//	   }else{
//		   return "login";
//	   }
//   }
//   
//   
//   @RequestMapping(path={"/inicio"},method=RequestMethod.GET)
//   public String  inicio(Model model,HttpServletRequest request) {
//	   Usuario pUsuario=(Usuario)request.getSession().getAttribute("p_usuario");
//	   if(pUsuario!=null&&pUsuario.getUsuarioId()>0){
//		   return "index";
//	   }else{
//		   return "login";
//	   }
//   }
//   
//   @RequestMapping(path={"/mante-servicio"},method=RequestMethod.GET)
//   public String  manteServicio(Model model,HttpServletRequest request) {
//	   Usuario pUsuario=(Usuario)request.getSession().getAttribute("p_usuario");
//	   if(pUsuario!=null&&pUsuario.getUsuarioId()>0){
//		   return "mante-servicio";
//	   }else{
//		   return "login";
//	   }
//   }
//   
//   @RequestMapping(path={"/mante-cliente"},method=RequestMethod.GET)
//   public String  manteCliente(Model model,HttpServletRequest request) {
//	   Usuario pUsuario=(Usuario)request.getSession().getAttribute("p_usuario");
//	   if(pUsuario!=null&&pUsuario.getUsuarioId()>0){
//		   return "mante-cliente";
//	   }else{
//		   return "login";
//	   }
//   }
//   
//   @RequestMapping(path={"/mante-lista-precios"},method=RequestMethod.GET)
//   public String  manteListaPrecios(Model model,HttpServletRequest request) {
//	   Usuario pUsuario=(Usuario)request.getSession().getAttribute("p_usuario");
//	   if(pUsuario!=null&&pUsuario.getUsuarioId()>0){
//		   return "mante-lista-precios";
//	   }else{
//		   return "login";
//	   }
//   }
//   
//   @RequestMapping(path={"/mante-tipo-cambio"},method=RequestMethod.GET)
//   public String  manteTipoCambio(Model model,HttpServletRequest request) {
//	   Usuario pUsuario=(Usuario)request.getSession().getAttribute("p_usuario");
//	   if(pUsuario!=null&&pUsuario.getUsuarioId()>0){
//		   
//		   ClienteBo servicio=new ClienteBo();
//		   
//		   String fechaHoy=servicio.getDate();
//		   model.addAttribute("fechaHoy", fechaHoy);
//		   
//		   return "mante-tipo-cambio";
//	   }else{
//		   return "login";
//	   }
//   }
//   
//   /****
//    * 
//    * @param model
//    * @param request
//    * @return
//    */
//   
//   @RequestMapping(path={"/registro-lista-precio"},method=RequestMethod.GET)
//   public String  registroListaPrecio(Model model,HttpServletRequest request) {
//	   Usuario pUsuario=(Usuario)request.getSession().getAttribute("p_usuario");
//	   if(pUsuario!=null&&pUsuario.getUsuarioId()>0){
//		   return "registro-lista-precio";
//	   }else{
//		   return "login";
//	   }
//   }
//   
//   @RequestMapping(path={"/registro-comp"},method=RequestMethod.GET)
//   public String registroGuia(Model model,HttpServletRequest request) {
//	   //Usuario pUsuario=(Usuario)request.getSession().getAttribute("p_usuario");
//	   //if(pUsuario!=null&&pUsuario.getUsuarioId()>0){
//		   	
//		    ClienteBo servicio=new ClienteBo();
//		    List lCliente=servicio.listaClientesGuia();
//		    List lListaPrecio=servicio.listaListaPrecio();
//		    List lPrioridad=servicio.listaPrioridad();
//		    //--
//		    ServicioBo serv=new ServicioBo(); 
//		    List lServicios=serv.listaServiciosGuia();
//		    
//		    model.addAttribute("listaClientes", lCliente);
//		    model.addAttribute("listaListaPrecio", lListaPrecio);
//		    model.addAttribute("listaPrioridad", lPrioridad);
//		    model.addAttribute("listaServicios", lServicios);
//		   
//		 /*  return "registro-comp";
//	   }else{
//		   return "login";
//	   }*/
//		    return "registro-comp";
//   }
//   
//   @RequestMapping(path={"/registro-comp-tabla"},method=RequestMethod.GET)
//   public String  registroGuiaTabla(Model model,HttpServletRequest request) {
//	   Usuario pUsuario=(Usuario)request.getSession().getAttribute("p_usuario");
//	   if(pUsuario!=null&&pUsuario.getUsuarioId()>0){
//		   return "registro-comp-tabla";
//	   }else{
//		   return "login";
//	   }
//   }
//
//   /**
//    * Reportes
//    */
//   @RequestMapping(path={"/reporte-pagos"},method=RequestMethod.GET)
//   public String  reportePagos(Model model,HttpServletRequest request) {
//	   Usuario pUsuario=(Usuario)request.getSession().getAttribute("p_usuario");
//	   if(pUsuario!=null&&pUsuario.getUsuarioId()>0){
//		   
//		   //--
//		   ClienteBo servicio=new ClienteBo();
//		   
//		   String fechaHoy=servicio.getDate();
//		   model.addAttribute("fechaHoy", fechaHoy);
//		   
//		   List lListaPrecio=servicio.listaListaPrecio();
//		   model.addAttribute("listaListaPrecio", lListaPrecio);
//		   //--
//		    
//		   return "reporte-pagos";
//	   }else{
//		   return "login";
//	   }
//   }
//   @RequestMapping(path={"/reporte-pagos-tabla"},method=RequestMethod.GET)
//   public String  reportePagosTabla(Model model,HttpServletRequest request) {
//	   Usuario pUsuario=(Usuario)request.getSession().getAttribute("p_usuario");
//	   if(pUsuario!=null&&pUsuario.getUsuarioId()>0){
//		   return "reporte-pagos-tabla";
//	   }else{
//		   return "login";
//	   }
//   }
//   
//   @RequestMapping(path={"/reporte-estado-ordenes"},method=RequestMethod.GET)
//   public String  reporteEstadoOrdenes(Model model,HttpServletRequest request) {
//	   Usuario pUsuario=(Usuario)request.getSession().getAttribute("p_usuario");
//	   if(pUsuario!=null&&pUsuario.getUsuarioId()>0){
//		   
//		 //--
//		   ClienteBo servicio=new ClienteBo();
//		   
//		   String fechaHoy=servicio.getDate();
//		   model.addAttribute("fechaHoy", fechaHoy);
//		   
//		   List lListaPrecio=servicio.listaListaPrecio();
//		   model.addAttribute("listaListaPrecio", lListaPrecio);
//		   //--
//		   
//		   return "reporte-estado-ordenes";
//	   }else{
//		   return "login";
//	   }
//   }
//   @RequestMapping(path={"/reporte-estado-ordenes-tabla"},method=RequestMethod.GET)
//   public String  reporteEstadoOrdenesTabla(Model model,HttpServletRequest request) {
//	   Usuario pUsuario=(Usuario)request.getSession().getAttribute("p_usuario");
//	   if(pUsuario!=null&&pUsuario.getUsuarioId()>0){
//		   return "registro-comp-tabla";
//	   }else{
//		   return "login";
//	   }
//   }
//   @RequestMapping(path={"/reporte-detalle-ordenes"},method=RequestMethod.GET)
//   public String  reporteDetalleOrdenes(Model model,HttpServletRequest request) {
//	   Usuario pUsuario=(Usuario)request.getSession().getAttribute("p_usuario");
//	   if(pUsuario!=null&&pUsuario.getUsuarioId()>0){
//		   //--
//		   ClienteBo servicio=new ClienteBo();
//		   
//		   String fechaHoy=servicio.getDate();
//		   model.addAttribute("fechaHoy", fechaHoy);
//		   
//		   List lListaPrecio=servicio.listaListaPrecio();
//		   model.addAttribute("listaListaPrecio", lListaPrecio);
//		   //--
//		   return "reporte-detalle-ordenes";
//	   }else{
//		   return "login";
//	   }
//   }
//   @RequestMapping(path={"/reporte-detalle-ordenes-tabla"},method=RequestMethod.GET)
//   public String  reporteDetalleOrdenesTabla(Model model,HttpServletRequest request) {
//	   Usuario pUsuario=(Usuario)request.getSession().getAttribute("p_usuario");
//	   if(pUsuario!=null&&pUsuario.getUsuarioId()>0){
//		   return "reporte-detalle-ordenes-tabla";
//	   }else{
//		   return "login";
//	   }
//   }
//   
//   
//   
//   //
//   @RequestMapping(path={"/proceso-dbf-concar"},method=RequestMethod.GET)
//   public String  procesoDbfConcar(Model model,HttpServletRequest request) {
//	   Usuario pUsuario=(Usuario)request.getSession().getAttribute("p_usuario");
//	   if(pUsuario!=null&&pUsuario.getUsuarioId()>0){
//		   ClienteBo servicio=new ClienteBo();
//		   String fechaHoy=servicio.getDate();
//		   model.addAttribute("fechaHoy", fechaHoy);
//		   return "proceso-dbf-concar";
//	   }else{
//		   return "login";
//	   }
//   }
//   
//   @RequestMapping(path={"/proceso-dbf-concar-tabla"},method=RequestMethod.GET)
//   public String  procesoDbfConcarTabla(Model model,HttpServletRequest request) {
//	   Usuario pUsuario=(Usuario)request.getSession().getAttribute("p_usuario");
//	   if(pUsuario!=null&&pUsuario.getUsuarioId()>0){
//		   return "proceso-dbf-concar-tabla";
//	   }else{
//		   return "login";
//	   }
//	   
//   }
//   
//   
//   /**
//    * Registro de ventas contable
//    */
//   @RequestMapping(path={"/reporte-venta"},method=RequestMethod.GET)
//   public String  reporteRegistroVentas(Model model,HttpServletRequest request) {
//	   Usuario pUsuario=(Usuario)request.getSession().getAttribute("p_usuario");
//	   if(pUsuario!=null&&pUsuario.getUsuarioId()>0){
//		   
//		   ClienteBo servicio=new ClienteBo();
//		   String fechaHoy=servicio.getDate();
//		   model.addAttribute("fechaHoy", fechaHoy);
//		    
//		   return "reporte-venta";
//	   }else{
//		   return "login";
//	   }
//   }
//   
//   @RequestMapping(path={"/reporte-venta-tabla"},method=RequestMethod.GET)
//   public String  reporteRegistroVentasTabla(Model model,HttpServletRequest request) {
//	   Usuario pUsuario=(Usuario)request.getSession().getAttribute("p_usuario");
//	   if(pUsuario!=null&&pUsuario.getUsuarioId()>0){
//		   return "reporte-venta-tabla";
//	   }else{
//		   return "login";
//	   }
//   }
//   
//   /**
//    * Registro de inventario kardex contable
//    */
//   @RequestMapping(path={"/reporte-inventario"},method=RequestMethod.GET)
//   public String  reporteRegistroInventario(Model model,HttpServletRequest request) {
//	   Usuario pUsuario=(Usuario)request.getSession().getAttribute("p_usuario");
//	   if(pUsuario!=null&&pUsuario.getUsuarioId()>0){
//		   
//		   ClienteBo servicio=new ClienteBo();
//		   String fechaHoy=servicio.getDate();
//		   model.addAttribute("fechaHoy", fechaHoy);
//		    
//		   return "reporte-inventario";
//	   }else{
//		   return "login";
//	   }
//   }
//   
//   @RequestMapping(path={"/reporte-inventario-tabla"},method=RequestMethod.GET)
//   public String  reporteRegistroInventarioTabla(Model model,HttpServletRequest request) {
//	   Usuario pUsuario=(Usuario)request.getSession().getAttribute("p_usuario");
//	   if(pUsuario!=null&&pUsuario.getUsuarioId()>0){
//		   return "reporte-inventario-tabla";
//	   }else{
//		   return "login";
//	   }
//   }
   
}
