package com.delfines.spring.controller;

import java.io.IOException;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.text.DateFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.GregorianCalendar;
import java.util.List;
import java.util.Properties;

import com.delfines.business.ClienteBo;
import com.delfines.business.RegistroFacturaBo;
import com.delfines.business.Util;
import com.delfines.vo.Cancelacion;
import com.delfines.vo.CancelacionDetalle;
import com.delfines.vo.Cliente;
import com.delfines.vo.ComprobanteDetalleDBF;
import com.delfines.vo.TipoCambio;
import com.linuxense.javadbf.DBFException;

public class JavaOpera2DBFWriteCancel {
	private static String sJdbURL;
	
	/*
	101101       CAJA M.N.  
	103103       REMESAS EN TRANSITO VISA
	103104       REMESAS EN TRANSITO-MASTERCARD
	103105       REMESAS EN TRANSITO-AMERICA EXPRESS
	103106       REMESAS EN TRANSITO-DINERS
	141101       PRESTAMOS DE PERSONAL EMPLEADOS MN
	141111       PRESTAMOS DE PERSONAL OBREROS MN
	*/
	
	public static String getsJdbURL() {
		return sJdbURL;
	}

	public static void setsJdbURL(String sJdbURL) {
		JavaOpera2DBFWriteCancel.sJdbURL = sJdbURL;
	}

	private String folderName;
	
	public String getFolderName() {
		return folderName;
	}

	public void setFolderName(String folderName) {
		this.folderName = folderName;
	}
	
	public JavaOpera2DBFWriteCancel(String fechaComp){
		try{
			ClienteBo cliente=new ClienteBo();
			String folder=cliente.getDateFolder(fechaComp);
			Util.createFolderCONCARCANCEL(folder);
			setFolderName(Util.pathCONCARCANCEL+folder+"\\");
			setsJdbURL("jdbc:dbf://"+getFolderName()+"/?caseInsensitive=true");
		}catch(Exception e){
			e.printStackTrace();
			setFolderName(Util.pathCONCARCANCEL);
			setsJdbURL("jdbc:dbf://"+getFolderName()+"/?caseInsensitive=true");
	    }
	}
	
	public Integer createDBFConcar(String fechaComprobante)throws Exception,DBFException, IOException,ParseException {
		RegistroFacturaBo bo=new RegistroFacturaBo();
		
		Integer periodo=Util.getYear(fechaComprobante);
		
		TipoCambio tipoCambio=bo.obtenerTipoCambioVenta(fechaComprobante);
		if(tipoCambio!=null && tipoCambio.getTipoCambioVenta()>0){
			List<Cancelacion> lHeader=bo.listaCancelacion(fechaComprobante);
			Integer cantidad=lHeader.size();
			if(cantidad>0){
				List<CancelacionDetalle> lDetailFormaPago=bo.listaCancelacionDetalleFormaPago(fechaComprobante);
				List<CancelacionDetalle> lDetailComprobante=bo.listaCancelacionDetalleComprobante(fechaComprobante);
				List<CancelacionDetalle> lDetailDiferencia=bo.listaCancelacionDetalleDiferencia(fechaComprobante);
				createCabeceraDBF(periodo,lHeader,tipoCambio);
			    createDetalleDBF(periodo,lDetailFormaPago,lDetailComprobante,lDetailDiferencia);
			}
		}else{
			throw new Exception("No registra tipo de cambio para la fecha"+fechaComprobante);
		}
		return 1;
	}
	
	public void createCabeceraDBF(Integer periodo,List<Cancelacion> lheader,TipoCambio tipoCambio)throws DBFException, IOException,ParseException {
	  try{
		  Class.forName("com.caigen.sql.dbf.DBFDriver");

          Properties props = new Properties();
          props.setProperty("delayedClose", "0");
          props.setProperty("versionNumber", "F5");
          
          Connection conn = DriverManager.getConnection(getsJdbURL(), props);
          Statement stmt = conn.createStatement(ResultSet.TYPE_SCROLL_SENSITIVE, ResultSet.CONCUR_UPDATABLE);

          String sql="drop table if exists CC0002"+String.valueOf(periodo)+";";
          stmt.execute(sql);
          
          sql="create table if not exists CC0002"+String.valueOf(periodo)+"(CSUBDIA CHAR(4),CCOMPRO CHAR(6),CFECCOM CHAR(6),CCODMON CHAR(2),CSITUA CHAR(1),CTIPCAM NUMERIC(9,4),CGLOSA CHAR(40),CTOTAL NUMERIC(13,2),CTIPO CHAR(1),CFLAG CHAR(1),CDATE DATE,CHORA CHAR(6),CFECCAM CHAR(6),CUSER CHAR(5),CORIG CHAR(2),CFORM CHAR(1),CTIPCOM CHAR(2),CEXTOR CHAR(1) );";
          stmt.execute(sql);
              
          for(Cancelacion header:lheader){
              //ASIGNA DATA :: INICIO
              Object []rowObjects=new Object [18];
              rowObjects[0]=header.getCSUBDIA();//CSUBDIA DE CANCELACION DE PAGOS
              rowObjects[1]=header.getCCOMPRO();//CCOMPRO
              rowObjects[2]=header.getCFECCOM();//CFECCOM
              rowObjects[3]=header.getCCODMON();//CCODMON
              rowObjects[4]=header.getCSITUA();//CSITUA
              rowObjects[5]=tipoCambio.getTipoCambioVenta();//CTIPCAM
              rowObjects[6]=header.getCGLOSA();//CGLOSA
              rowObjects[7]=header.getCTOTAL();//header.getTotalGeneral();//CTOTAL
              rowObjects[8]=header.getCTIPO();//CTIPO
              rowObjects[9]=header.getCFLAG();//CFLAG
              	rowObjects[10]=header.getCDATE();//CDATE
              rowObjects[11]=header.getCHORA();//CHORA
              rowObjects[12]=header.getCFECCAM();//CFECCAM
              rowObjects[13]=header.getCUSER();//CUSER
              rowObjects[14]=header.getCORIG();//CORIG
              rowObjects[15]=header.getCFORM();//CFORM
              rowObjects[16]=header.getCTIPCOM();//CTIPCOM
              rowObjects[17]=header.getCEXTOR();//CEXTOR
              //ASIGNA DATA :: FIN
              
	    		StringBuilder query = new StringBuilder();
	    		query.append("insert into CC0002"+String.valueOf(periodo)+"(CSUBDIA,CCOMPRO,CFECCOM,CCODMON,CSITUA,CTIPCAM,CGLOSA,CTOTAL,CTIPO,CFLAG,CDATE,CHORA,CFECCAM,CUSER,CORIG,CFORM,CTIPCOM,CEXTOR) values(");
	    		query.append("'"+rowObjects[0]+"',");//CSUBDIA 4 0 67
	    		query.append("'"+rowObjects[1]+"',");//CCOMPRO 6 0 67
	    		query.append("'"+rowObjects[2]+"',");//CFECCOM 6 0 67
	    		query.append("'"+rowObjects[3]+"',");//CCODMON 2 0 67
	    		query.append("'"+rowObjects[4]+"',");//CSITUA 1 0 67
	    		query.append(new Double(rowObjects[5]==null?"0.0":rowObjects[5].toString())+",");//    CTIPCAM 10 4 78
	    		query.append("'"+rowObjects[6]+"',");//CGLOSA 40 0 67
	    		query.append(new Double(rowObjects[7]==null?"0.0":rowObjects[7].toString())+",");//CTOTAL 14 2 78
	    		query.append("'"+rowObjects[8]+"',");//CTIPO 1 0 67
	    		query.append("'"+rowObjects[9]+"',");//CFLAG 1 0 67
	    		
	    		if(rowObjects[10]!=null){
	    			DateFormat df = new SimpleDateFormat("dd/MM/yyyy");
			        GregorianCalendar calendar = new GregorianCalendar();
					calendar.setTime(df.parse(rowObjects[10].toString()));
					
					String year=String.valueOf(calendar.get(Calendar.YEAR));
					String month=String.valueOf(calendar.get(Calendar.MONTH) + 1);
					month=fill(month,2);
					String day=String.valueOf(calendar.get(Calendar.DAY_OF_MONTH));
					day=fill(day,2);
					
					query.append("CDATE('"+month+day+year+"','MMddyyyy'),");//CDATE 8 0 68
	    		}else{
	    			query.append("'',");
	    		}
	    		query.append("'"+rowObjects[11]+"',");//CHORA CHAR(6),
	    		query.append("'"+rowObjects[12]+"',");//CFECCAM CHAR(6),
	    		query.append("'"+rowObjects[13]+"',");//CUSER CHAR(5),
	    		query.append("'"+rowObjects[14]+"',");//CORIG 2 0 67
	    		query.append("'"+rowObjects[15]+"',");//CFORM 1 0 67
	    		query.append("'"+rowObjects[16]+"',");//CTIPCOM 2 0 67
	    		query.append("'"+rowObjects[17]+"'");//CEXTOR 1 0 67
	    		query.append(");");
	    		
	    		System.out.println(query.toString());
	            stmt.execute(query.toString());
            }
		    stmt.close();
            conn.close();
        }
        catch( SQLException sqle )
        {
            do
            {
                System.out.println(sqle.getMessage());
                System.out.println("Error Code:"+sqle.getErrorCode());
                System.out.println("SQL State:"+sqle.getSQLState());
                sqle.printStackTrace();
            }while((sqle=sqle.getNextException())!=null);
        }
        catch( Exception e )
        {
            System.out.println(e.getMessage());
            e.printStackTrace();
        }
    }
	
														 
	public void createDetalleDBF(Integer periodo,List<CancelacionDetalle> lDetailFormaPago,List<CancelacionDetalle> lDetailComprobante,List<CancelacionDetalle> lDetailDiferencia)throws DBFException, IOException,ParseException {
		  try{
              Class.forName("com.caigen.sql.dbf.DBFDriver");

              Properties props = new Properties();
              props.setProperty("delayedClose", "0");
              props.setProperty("versionNumber", "F5");

              Connection conn = DriverManager.getConnection(getsJdbURL(), props);
              Statement stmt = conn.createStatement(ResultSet.TYPE_SCROLL_SENSITIVE, ResultSet.CONCUR_UPDATABLE);

              String sql="drop table if exists CD0002"+String.valueOf(periodo)+";";
              stmt.execute(sql);
              
              sql="create table if not exists CD0002"+String.valueOf(periodo)+"(DSUBDIA CHAR(4),DCOMPRO CHAR(6),DSECUE CHAR(4),DFECCOM CHAR(6),DCUENTA CHAR(12),DCODANE CHAR(18),DCENCOS CHAR(6),DCODMON CHAR(2),DDH CHAR(1),DIMPORT NUMERIC(13,2),DTIPDOC CHAR(2),DNUMDOC VARCHAR(20),DFECDOC CHAR(6),DFECVEN CHAR(6),DAREA CHAR(3),DFLAG CHAR(1),DXGLOSA VARCHAR(30),DDATE DATE,DCODANE2 CHAR(18),DUSIMPOR NUMERIC(13,2),DMNIMPOR NUMERIC(13,2),DCODARC CHAR(2),FLAGX CHAR(1),DMEDPAG CHAR(8),DIGVCOM NUMERIC(13,2),DTIDREF CHAR(2),DNDOREF CHAR(30),DFECREF DATE,DBIMREF NUMERIC(13,2),DIGVREF NUMERIC(13,2),DMAQREF CHAR(20) );";
              stmt.execute(sql);
              
              Integer secuencia=0;
              
              for(CancelacionDetalle detalle:lDetailFormaPago){
              //(1)
		    	  //ASIGNA DATA :: INICIO
		    	  Object []rowObjects=new Object [31];
	              rowObjects[0]=detalle.getCSUBDIA();//CSUBDIA
	              rowObjects[1]=detalle.getCCOMPRO();//CCOMPRO
	              rowObjects[2]=fill(++secuencia,4);//DSECUE 4 0 67
	              rowObjects[3]=detalle.getDFECCOM();//DFECCOM 6 0 67
	              rowObjects[4]=detalle.getDCUENTA();//DCUENTA 12 0 67
	              rowObjects[5]=detalle.getDCODANE();//DCODANE 18 0 67
	              rowObjects[6]=detalle.getDCENCOS();//DCENCOS 6 0 67
	              rowObjects[7]=detalle.getDCODMON();//DCODMON
	              rowObjects[8]=detalle.getDDH();//DDH
	              rowObjects[9]=detalle.getDIMPORT();//DIMPORT
	              rowObjects[10]=detalle.getDTIPDOC();//DTIPDOC 2 0 67
	              rowObjects[11]=detalle.getDNUMDOC();//DNUMDOC 2 0 67
	              rowObjects[12]=detalle.getDFECDOC();//DFECDOC 2 0 67
	              rowObjects[13]=detalle.getDFECVEN();//DFECVEN 2 0 67
	              rowObjects[14]=detalle.getDAREA();//DAREA 2 0 67
	              rowObjects[15]=detalle.getDFLAG();//DFLAG FLAG DE CONVERSIN DE MONEDA (S, N) 
	              rowObjects[16]=detalle.getDXGLOSA();//DXGLOSA GLOSA DEL MOVIMIENTO 
	              rowObjects[17]=detalle.getDDATE();//DDATE FECHA DE ACTUALIZACIN 
	              rowObjects[18]=detalle.getDCODANE2();//DCODANE2 CDIGO DE ANEXO AUXILAR
	              rowObjects[19]=detalle.getDUSIMPOR();//DUSIMPOR NUMERIC(14,2),
	              rowObjects[20]=detalle.getDMNIMPOR();//DMNIMPOR NUMERIC(14,2),
	              rowObjects[21]=detalle.getDCODARC();//DCODARC
	              rowObjects[22]=detalle.getFLAGX();//FLAGX
	              rowObjects[23]=detalle.getDMEDPAG();//DMEDPAG
	              rowObjects[24]=detalle.getDIGVCOM();//DIGVCOM NUMERIC(14,2),
	              rowObjects[25]=detalle.getDTIDREF();//DTIDREF
	              rowObjects[26]=detalle.getDNDOREF();//DNDOREF
	              rowObjects[27]=detalle.getDFECREF();//DFECREF
	              rowObjects[28]=detalle.getDBIMREF();//DBIMREF
	              rowObjects[29]=detalle.getDIGVREF();//DIGVREF
	              rowObjects[30]=detalle.getDMAQREF();//DMAQREF
	              //ASIGNA DATA :: FIN 
		    	  
		    		StringBuilder query = new StringBuilder();
		    		query.append("insert into CD0002"+String.valueOf(periodo)+"(DSUBDIA,DCOMPRO,DSECUE,DFECCOM,DCUENTA,DCODANE,DCENCOS,DCODMON,DDH,DIMPORT,DTIPDOC,DNUMDOC,DFECDOC,DFECVEN,DAREA,DFLAG,DXGLOSA,DDATE,DCODANE2,DUSIMPOR,DMNIMPOR,DCODARC,FLAGX,DMEDPAG,DIGVCOM,DTIDREF,DNDOREF,DFECREF,DBIMREF,DIGVREF,DMAQREF) values(");
		    		query.append("'"+rowObjects[0]+"',");//DSUBDIA 4 0 67
		    		query.append("'"+rowObjects[1]+"',");//DCOMPRO 6 0 67
		    		query.append("'"+rowObjects[2]+"',");//DSECUE 4 0 67
		    		query.append("'"+rowObjects[3]+"',");//DFECCOM 6 0 67
		    		query.append("'"+rowObjects[4]+"',");//DCUENTA 12 0 67
		    		query.append("'"+rowObjects[5]+"',");//DCODANE 18 0 67
		    		query.append("'"+rowObjects[6]+"',");//DCENCOS 6 0 67
		    		query.append("'"+rowObjects[7]+"',");//DCODMON 2 0 67
		    		query.append("'"+rowObjects[8]+"',");//DDH 1 0 67
		    		query.append(new Double(rowObjects[9]==null?"0.0":rowObjects[9].toString())+",");//DIMPORT 14 2 78
		    		query.append("'"+rowObjects[10]+"',");//DTIPDOC 2 0 67
		    		query.append("'"+rowObjects[11]+"',");//DNUMDOC 20 0 67
		    		query.append("'"+rowObjects[12]+"',");//DFECDOC 6 0 67
		    		query.append("'"+rowObjects[13]+"',");//DFECVEN 6 0 67
		    		query.append("'"+rowObjects[14]+"',");//DAREA 3 0 67
		    		query.append("'"+rowObjects[15]+"',");//DFLAG 1 0 67
		    		query.append("'"+rowObjects[16]+"',");//DXGLOSA 30 0 67
		    		
		    		if(rowObjects[17]!=null){
		    			DateFormat df = new SimpleDateFormat("dd/MM/yyyy");
				        GregorianCalendar calendar = new GregorianCalendar();
				        calendar.setTime(df.parse(rowObjects[17].toString()));
						
						String year=String.valueOf(calendar.get(Calendar.YEAR));
						String month=String.valueOf(calendar.get(Calendar.MONTH) + 1);
						month=fill(month,2);
						String day=String.valueOf(calendar.get(Calendar.DAY_OF_MONTH));
						day=fill(day,2);
						
						query.append("CDATE('"+month+day+year+"','MMddyyyy'),");//CDATE 8 0 68
		    		}else{
		    			query.append("'',");
		    		}
		    		query.append("'"+rowObjects[18]+"',");//DCODANE2 CHAR(18),
		    		query.append(new Double(rowObjects[19]==null?"0.0":rowObjects[19].toString())+",");//DUSIMPOR NUMERIC(14,2),
		    		query.append(new Double(rowObjects[20]==null?"0.0":rowObjects[20].toString())+",");//DMNIMPOR NUMERIC(14,2),
		    		query.append("'',");//DCODARC CHAR(2),
		    		query.append("'',");//FLAGX CHAR(1),
		    		query.append("'',");//DMEDPAG CHAR(8),
		    		query.append("'',");//DIGVCOM NUMERIC(14,2),
		    		query.append("'',");//DTIDREF CHAR(2),
		    		query.append("'',");//DNDOREF CHAR(30),
	    			query.append("'',");//DFECREF
		    		query.append("'',");//DBIMREF NUMERIC(14,2),
		    		query.append("'',");//DIGVREF NUMERIC(14,2),
		    		query.append("''");//DMAQREF CHAR(20)
		    		query.append(");");
		    		
		    		System.out.println(query.toString());
	                stmt.execute(query.toString());
            }
             
            
	          for(CancelacionDetalle detalle:lDetailComprobante){
	              //(1)
			    	  //ASIGNA DATA :: INICIO
			    	  Object []rowObjects=new Object [31];
		              rowObjects[0]=detalle.getCSUBDIA();//CSUBDIA
		              rowObjects[1]=detalle.getCCOMPRO();//CCOMPRO
		              rowObjects[2]=fill(++secuencia,4);//DSECUE 4 0 67
		              rowObjects[3]=detalle.getDFECCOM();//DFECCOM 6 0 67
		              rowObjects[4]=detalle.getDCUENTA();//DCUENTA 12 0 67
		              rowObjects[5]=detalle.getDCODANE();//DCODANE 18 0 67
		              rowObjects[6]=detalle.getDCENCOS();//DCENCOS 6 0 67
		              rowObjects[7]=detalle.getDCODMON();//DCODMON
		              rowObjects[8]=detalle.getDDH();//DDH
		              rowObjects[9]=detalle.getDIMPORT();//DIMPORT
		              rowObjects[10]=detalle.getDTIPDOC();//DTIPDOC 2 0 67
		              rowObjects[11]=detalle.getDNUMDOC();//DNUMDOC 2 0 67
		              rowObjects[12]=detalle.getDFECDOC();//DFECDOC 2 0 67
		              rowObjects[13]=detalle.getDFECVEN();//DFECVEN 2 0 67
		              rowObjects[14]=detalle.getDAREA();//DAREA 2 0 67
		              rowObjects[15]=detalle.getDFLAG();//DFLAG FLAG DE CONVERSIN DE MONEDA (S, N) 
		              rowObjects[16]=detalle.getDXGLOSA();//DXGLOSA GLOSA DEL MOVIMIENTO 
		              rowObjects[17]=detalle.getDDATE();//DDATE FECHA DE ACTUALIZACIN 
		              rowObjects[18]=detalle.getDCODANE2();//DCODANE2 CDIGO DE ANEXO AUXILAR
		              rowObjects[19]=detalle.getDUSIMPOR();//DUSIMPOR NUMERIC(14,2),
		              rowObjects[20]=detalle.getDMNIMPOR();//DMNIMPOR NUMERIC(14,2),
		              rowObjects[21]=detalle.getDCODARC();//DCODARC
		              rowObjects[22]=detalle.getFLAGX();//FLAGX
		              rowObjects[23]=detalle.getDMEDPAG();//DMEDPAG
		              rowObjects[24]=detalle.getDIGVCOM();//DIGVCOM NUMERIC(14,2),
		              rowObjects[25]=detalle.getDTIDREF();//DTIDREF
		              rowObjects[26]=detalle.getDNDOREF();//DNDOREF
		              rowObjects[27]=detalle.getDFECREF();//DFECREF
		              rowObjects[28]=detalle.getDBIMREF();//DBIMREF
		              rowObjects[29]=detalle.getDIGVREF();//DIGVREF
		              rowObjects[30]=detalle.getDMAQREF();//DMAQREF
		              //ASIGNA DATA :: FIN 
			    	  
			    		StringBuilder query = new StringBuilder();
			    		query.append("insert into CD0002"+String.valueOf(periodo)+"(DSUBDIA,DCOMPRO,DSECUE,DFECCOM,DCUENTA,DCODANE,DCENCOS,DCODMON,DDH,DIMPORT,DTIPDOC,DNUMDOC,DFECDOC,DFECVEN,DAREA,DFLAG,DXGLOSA,DDATE,DCODANE2,DUSIMPOR,DMNIMPOR,DCODARC,FLAGX,DMEDPAG,DIGVCOM,DTIDREF,DNDOREF,DFECREF,DBIMREF,DIGVREF,DMAQREF) values(");
			    		query.append("'"+rowObjects[0]+"',");//DSUBDIA 4 0 67
			    		query.append("'"+rowObjects[1]+"',");//DCOMPRO 6 0 67
			    		query.append("'"+rowObjects[2]+"',");//DSECUE 4 0 67
			    		query.append("'"+rowObjects[3]+"',");//DFECCOM 6 0 67
			    		query.append("'"+rowObjects[4]+"',");//DCUENTA 12 0 67
			    		query.append("'"+rowObjects[5]+"',");//DCODANE 18 0 67
			    		query.append("'"+rowObjects[6]+"',");//DCENCOS 6 0 67
			    		query.append("'"+rowObjects[7]+"',");//DCODMON 2 0 67
			    		query.append("'"+rowObjects[8]+"',");//DDH 1 0 67
			    		query.append(new Double(rowObjects[9]==null?"0.0":rowObjects[9].toString())+",");//DIMPORT 14 2 78
			    		query.append("'"+rowObjects[10]+"',");//DTIPDOC 2 0 67
			    		query.append("'"+rowObjects[11]+"',");//DNUMDOC 20 0 67
			    		query.append("'"+rowObjects[12]+"',");//DFECDOC 6 0 67
			    		query.append("'"+rowObjects[13]+"',");//DFECVEN 6 0 67
			    		query.append("'"+rowObjects[14]+"',");//DAREA 3 0 67
			    		query.append("'"+rowObjects[15]+"',");//DFLAG 1 0 67
			    		query.append("'"+rowObjects[16]+"',");//DXGLOSA 30 0 67
			    		
			    		if(rowObjects[17]!=null){
			    			DateFormat df = new SimpleDateFormat("dd/MM/yyyy");
					        GregorianCalendar calendar = new GregorianCalendar();
					        calendar.setTime(df.parse(rowObjects[17].toString()));
							
							String year=String.valueOf(calendar.get(Calendar.YEAR));
							String month=String.valueOf(calendar.get(Calendar.MONTH) + 1);
							month=fill(month,2);
							String day=String.valueOf(calendar.get(Calendar.DAY_OF_MONTH));
							day=fill(day,2);
							
							query.append("CDATE('"+month+day+year+"','MMddyyyy'),");//CDATE 8 0 68
			    		}else{
			    			query.append("'',");
			    		}
			    		query.append("'"+rowObjects[18]+"',");//DCODANE2 CHAR(18),
			    		query.append(new Double(rowObjects[19]==null?"0.0":rowObjects[19].toString())+",");//DUSIMPOR NUMERIC(14,2),
			    		query.append(new Double(rowObjects[20]==null?"0.0":rowObjects[20].toString())+",");//DMNIMPOR NUMERIC(14,2),
			    		query.append("'',");//DCODARC CHAR(2),
			    		query.append("'',");//FLAGX CHAR(1),
			    		query.append("'',");//DMEDPAG CHAR(8),
			    		query.append("'',");//DIGVCOM NUMERIC(14,2),
			    		query.append("'',");//DTIDREF CHAR(2),
			    		query.append("'',");//DNDOREF CHAR(30),
		    			query.append("'',");//DFECREF
			    		query.append("'',");//DBIMREF NUMERIC(14,2),
			    		query.append("'',");//DIGVREF NUMERIC(14,2),
			    		query.append("''");//DMAQREF CHAR(20)
			    		query.append(");");
			    		
			    		System.out.println(query.toString());
		                stmt.execute(query.toString());
	            }
              
	          
	          
	          for(CancelacionDetalle detalle:lDetailDiferencia){
	              //(1)
			    	  //ASIGNA DATA :: INICIO
			    	  Object []rowObjects=new Object [31];
		              rowObjects[0]=detalle.getCSUBDIA();//CSUBDIA
		              rowObjects[1]=detalle.getCCOMPRO();//CCOMPRO
		              rowObjects[2]=fill(++secuencia,4);//DSECUE 4 0 67
		              rowObjects[3]=detalle.getDFECCOM();//DFECCOM 6 0 67
		              rowObjects[4]=detalle.getDCUENTA();//DCUENTA 12 0 67
		              rowObjects[5]=detalle.getDCODANE();//DCODANE 18 0 67
		              rowObjects[6]=detalle.getDCENCOS();//DCENCOS 6 0 67
		              rowObjects[7]=detalle.getDCODMON();//DCODMON
		              rowObjects[8]=detalle.getDDH();//DDH
		              rowObjects[9]=detalle.getDIMPORT();//DIMPORT
		              rowObjects[10]=detalle.getDTIPDOC();//DTIPDOC 2 0 67
		              rowObjects[11]=detalle.getDNUMDOC();//DNUMDOC 2 0 67
		              rowObjects[12]=detalle.getDFECDOC();//DFECDOC 2 0 67
		              rowObjects[13]=detalle.getDFECVEN();//DFECVEN 2 0 67
		              rowObjects[14]=detalle.getDAREA();//DAREA 2 0 67
		              rowObjects[15]=detalle.getDFLAG();//DFLAG FLAG DE CONVERSIN DE MONEDA (S, N) 
		              rowObjects[16]=detalle.getDXGLOSA();//DXGLOSA GLOSA DEL MOVIMIENTO 
		              rowObjects[17]=detalle.getDDATE();//DDATE FECHA DE ACTUALIZACIN 
		              rowObjects[18]=detalle.getDCODANE2();//DCODANE2 CDIGO DE ANEXO AUXILAR
		              rowObjects[19]=detalle.getDUSIMPOR();//DUSIMPOR NUMERIC(14,2),
		              rowObjects[20]=detalle.getDMNIMPOR();//DMNIMPOR NUMERIC(14,2),
		              rowObjects[21]=detalle.getDCODARC();//DCODARC
		              rowObjects[22]=detalle.getFLAGX();//FLAGX
		              rowObjects[23]=detalle.getDMEDPAG();//DMEDPAG
		              rowObjects[24]=detalle.getDIGVCOM();//DIGVCOM NUMERIC(14,2),
		              rowObjects[25]=detalle.getDTIDREF();//DTIDREF
		              rowObjects[26]=detalle.getDNDOREF();//DNDOREF
		              rowObjects[27]=detalle.getDFECREF();//DFECREF
		              rowObjects[28]=detalle.getDBIMREF();//DBIMREF
		              rowObjects[29]=detalle.getDIGVREF();//DIGVREF
		              rowObjects[30]=detalle.getDMAQREF();//DMAQREF
		              //ASIGNA DATA :: FIN 
			    	  
			    		StringBuilder query = new StringBuilder();
			    		query.append("insert into CD0002"+String.valueOf(periodo)+"(DSUBDIA,DCOMPRO,DSECUE,DFECCOM,DCUENTA,DCODANE,DCENCOS,DCODMON,DDH,DIMPORT,DTIPDOC,DNUMDOC,DFECDOC,DFECVEN,DAREA,DFLAG,DXGLOSA,DDATE,DCODANE2,DUSIMPOR,DMNIMPOR,DCODARC,FLAGX,DMEDPAG,DIGVCOM,DTIDREF,DNDOREF,DFECREF,DBIMREF,DIGVREF,DMAQREF) values(");
			    		query.append("'"+rowObjects[0]+"',");//DSUBDIA 4 0 67
			    		query.append("'"+rowObjects[1]+"',");//DCOMPRO 6 0 67
			    		query.append("'"+rowObjects[2]+"',");//DSECUE 4 0 67
			    		query.append("'"+rowObjects[3]+"',");//DFECCOM 6 0 67
			    		query.append("'"+rowObjects[4]+"',");//DCUENTA 12 0 67
			    		query.append("'"+rowObjects[5]+"',");//DCODANE 18 0 67
			    		query.append("'"+rowObjects[6]+"',");//DCENCOS 6 0 67
			    		query.append("'"+rowObjects[7]+"',");//DCODMON 2 0 67
			    		query.append("'"+rowObjects[8]+"',");//DDH 1 0 67
			    		query.append(new Double(rowObjects[9]==null?"0.0":rowObjects[9].toString())+",");//DIMPORT 14 2 78
			    		query.append("'"+rowObjects[10]+"',");//DTIPDOC 2 0 67
			    		query.append("'"+rowObjects[11]+"',");//DNUMDOC 20 0 67
			    		query.append("'"+rowObjects[12]+"',");//DFECDOC 6 0 67
			    		query.append("'"+rowObjects[13]+"',");//DFECVEN 6 0 67
			    		query.append("'"+rowObjects[14]+"',");//DAREA 3 0 67
			    		query.append("'"+rowObjects[15]+"',");//DFLAG 1 0 67
			    		query.append("'"+rowObjects[16]+"',");//DXGLOSA 30 0 67
			    		
			    		if(rowObjects[17]!=null){
			    			DateFormat df = new SimpleDateFormat("dd/MM/yyyy");
					        GregorianCalendar calendar = new GregorianCalendar();
					        calendar.setTime(df.parse(rowObjects[17].toString()));
							
							String year=String.valueOf(calendar.get(Calendar.YEAR));
							String month=String.valueOf(calendar.get(Calendar.MONTH) + 1);
							month=fill(month,2);
							String day=String.valueOf(calendar.get(Calendar.DAY_OF_MONTH));
							day=fill(day,2);
							
							query.append("CDATE('"+month+day+year+"','MMddyyyy'),");//CDATE 8 0 68
			    		}else{
			    			query.append("'',");
			    		}
			    		query.append("'"+rowObjects[18]+"',");//DCODANE2 CHAR(18),
			    		query.append(new Double(rowObjects[19]==null?"0.0":rowObjects[19].toString())+",");//DUSIMPOR NUMERIC(14,2),
			    		query.append(new Double(rowObjects[20]==null?"0.0":rowObjects[20].toString())+",");//DMNIMPOR NUMERIC(14,2),
			    		query.append("'',");//DCODARC CHAR(2),
			    		query.append("'',");//FLAGX CHAR(1),
			    		query.append("'',");//DMEDPAG CHAR(8),
			    		query.append("'',");//DIGVCOM NUMERIC(14,2),
			    		query.append("'',");//DTIDREF CHAR(2),
			    		query.append("'',");//DNDOREF CHAR(30),
		    			query.append("'',");//DFECREF
			    		query.append("'',");//DBIMREF NUMERIC(14,2),
			    		query.append("'',");//DIGVREF NUMERIC(14,2),
			    		query.append("''");//DMAQREF CHAR(20)
			    		query.append(");");
			    		
			    		System.out.println(query.toString());
		                stmt.execute(query.toString());
	            }
	          
		    stmt.close();
            conn.close();
		}
        catch( SQLException sqle )
        {
            do
            {
                System.out.println(sqle.getMessage());
                System.out.println("Error Code:"+sqle.getErrorCode());
                System.out.println("SQL State:"+sqle.getSQLState());
                sqle.printStackTrace();
            }while((sqle=sqle.getNextException())!=null);
        }
        catch( Exception e )
        {
            System.out.println(e.getMessage());
            e.printStackTrace();
        }
	}
	
	
	public static String fill(String text, int size) {
        StringBuilder builder = new StringBuilder(text);
        while (builder.length() < size) {
            builder.insert(0,'0');
        }
        return builder.toString();
    }
	
	
	public static String fill(Integer secuencia, int size) {
        StringBuilder builder = new StringBuilder(String.valueOf(secuencia));
        while (builder.length() < size) {
            builder.insert(0,'0');
        }
        return builder.toString();
    }
}