package com.delfines.spring.controller;

import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.OutputStream;
import java.sql.Connection;
import java.util.HashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;

import com.delfines.business.ClienteBo;
import com.delfines.business.RegistroFacturaBo;
import com.delfines.dao.ConnectionFactory;
import com.delfines.vo.Comprobante;
import com.delfines.vo.ComprobanteDetalle;
import com.delfines.vo.QRComprobante;
import com.delfines.vo.Usuario;
import com.delfines.vo.Value;

import genfactura.GenFacturaIng;
import net.sf.jasperreports.engine.JasperFillManager;
import net.sf.jasperreports.engine.JasperPrint;
import net.sf.jasperreports.engine.JasperReport;
import net.sf.jasperreports.engine.export.JRPdfExporter;
import net.sf.jasperreports.engine.util.JRLoader;
import net.sf.jasperreports.export.SimpleExporterInput;
import net.sf.jasperreports.export.SimpleOutputStreamExporterOutput;


@Controller
public class RegistroComprobanteController {
   
	@RequestMapping(path={"/create-factura-desde-guia"}, method=RequestMethod.GET)
	public String crearFacturaDesdeGuia(Integer idGuia,Integer idComprobante,Model model,HttpServletRequest request) {
	   Usuario pUsuario=(Usuario)request.getSession().getAttribute("p_usuario");
	   if(pUsuario!=null&&pUsuario.getUsuarioId()>0){
		   
		   RegistroFacturaBo bo=new RegistroFacturaBo();
		   if(idComprobante==0){
			   idComprobante=bo.crearFacturaDesdeGuia(idGuia, pUsuario);
		   }
		   request.getSession().setAttribute("idComprobante", idComprobante);
		   
		   return "registro-factura";
	   }else{
		   return "login";
	   }
	}
	
	@RequestMapping(path={"/create-factura-desde-lista-guia"}, method=RequestMethod.GET)
	public String crearFacturaDesdeListaGuia(String idListaGuia,Model model,HttpServletRequest request) {
	   Usuario pUsuario=(Usuario)request.getSession().getAttribute("p_usuario");
	   if(pUsuario!=null&&pUsuario.getUsuarioId()>0){
		   Integer idComprobante=0;
		   RegistroFacturaBo bo=new RegistroFacturaBo();
		   if(idComprobante==0){
			   idComprobante=bo.crearFacturaDesdeListaGuia(idListaGuia, pUsuario);
		   }
		   request.getSession().setAttribute("idComprobante", idComprobante);
		   
		   return "registro-factura";
	   }else{
		   return "login";
	   }
	}
	

	@RequestMapping(path={"/registro-factura"},method=RequestMethod.GET)
    public String  registroFactura(Model model,HttpServletRequest request) {
	   //Usuario pUsuario=(Usuario)request.getSession().getAttribute("p_usuario");
	   //if(pUsuario!=null&&pUsuario.getUsuarioId()>0){
		   
		   RegistroFacturaBo bo=new RegistroFacturaBo();
		   
		   Integer idComprobante=(Integer)request.getSession().getAttribute("idComprobante");
		   if(idComprobante>0){
			   Comprobante cabecera=bo.obtenerComprobante(idComprobante);
			   //--para mostrar los datos del cliente
			   ClienteBo servicio=new ClienteBo();
			   Value cliente=servicio.getCliente(cabecera.getIdCliente());
			   model.addAttribute("cliente",cliente);
			   //--
			   model.addAttribute("comprobante",cabecera);
			   List<ComprobanteDetalle> lDetalle=bo.obtenerComprobanteDetalle(idComprobante);
			   model.addAttribute("lComprobanteDetalle",lDetalle);
			   
			   //Selecciona el Tipo de Comprobante
			   List<Value> listaTipoComprobante=new LinkedList<>();
			   if(cliente.getIdTipoDocumento()==2){//RUC
				   Value val=new Value();
				   val.setId(1);
				   val.setCodigo("FACTURA");   
				   
				   listaTipoComprobante.add(val);
			   }else{//DNI //C.EXT //PASSAP
				   Value val=new Value();
				   val.setId(2);
				   val.setCodigo("BOLETA");   
				   listaTipoComprobante.add(val);
			   }
			   model.addAttribute("listaTipoComprobante",listaTipoComprobante);
		   }
		   return "registro-factura";
		   
	   //}else{
		 //  return "login";
	   //}
    }
	
	/**
	 * Completa e imprime los comprobantes
	 * @param model
	 * @param request
	 * @return
	 */
	@RequestMapping(value={"/complete-factura"}, method=RequestMethod.GET)
	@ResponseBody
	public String completeFactura(Integer idTipoComprobante,String descripcion,Integer idComprobante,Model model,HttpServletRequest request) {
	   Usuario pUsuario=(Usuario)request.getSession().getAttribute("p_usuario");
	   if(pUsuario!=null&&pUsuario.getUsuarioId()>0){
		   request.getSession().setAttribute("idComprobante", idComprobante);
		   
		   RegistroFacturaBo bo=new RegistroFacturaBo();
		
		   if(!bo.esComprobanteCompleto(idComprobante)){
			   HashMap<String, String> comprobante=bo.getNumeroComprobante(idTipoComprobante);
			   String numero=comprobante.get("numero");
			   String serie=comprobante.get("serie");
		    	if(numero!=null){
		    		
		    		/**ACTUALIZA SECUENCIALES : INICIO**/
		    		Integer secuencia=Integer.valueOf(comprobante.get("secuencia")==null?"0":comprobante.get("secuencia"));
		    		bo.actualizarComprobante(idTipoComprobante, descripcion, numero,secuencia,serie,idComprobante, pUsuario);//DATOS GOSOCKET
		    		bo.asignarSeqMesConcar(idComprobante);//DATOS CONCAR
		    		/**ACTUALIZA SECUENCIALES : FIN**/
				   
		    		/**GENERA ARCHIVO GOSOCKET : INICIO**/
				    Comprobante cabecera=bo.obtenerComprobante(idComprobante);
				    List<ComprobanteDetalle> lDetalle=bo.obtenerComprobanteDetalleConsolidado(idComprobante); 
				   
				    JavaGoSocketWrite write=new JavaGoSocketWrite();
				    /*
				    if(cabecera.getIdTipoComprobante()==Constante.ID_TIPO_COMPROBANTE_FACTURA){
					   write.createF013(cabecera, lDetalle);
				    }else{
					   write.createB013(cabecera, lDetalle);
				    }
				    */
				    
				    String dataDirectory = request.getServletContext().getRealPath("/WEB-INF/downloads/zip/");
				    System.out.println("111"+dataDirectory);
				    GenFacturaIng comp=new GenFacturaIng(dataDirectory); 
				    comp.enviarComprobanteToSunat(cabecera, lDetalle);
				    
				    /**GENERA ARCHIVO GOSOCKET : FIN**/
				    return numero;
		    	}else{
		    		return "";	
		    	}
		   }else{
			   return "";
		   }
	   }else{
		   return "";
	   }
	}
	
	@RequestMapping(path={"/print-factura"}, method=RequestMethod.GET)
	public String printFactura(Integer idComprobante,Model model,HttpServletRequest request) {
	   Usuario pUsuario=(Usuario)request.getSession().getAttribute("p_usuario");
	   if(pUsuario!=null&&pUsuario.getUsuarioId()>0){
		   request.getSession().setAttribute("idComprobante", idComprobante);
		   RegistroFacturaBo bo=new RegistroFacturaBo();
		   Comprobante comprobante=bo.obtenerComprobante(idComprobante);
		   request.getSession().setAttribute("p_lista_guia", comprobante.getListGuia());
		   //Registrar los usuarios que estan haciendo la impresion de los comporbantes
		   return "registro-factura";
	   }else{
		   return "login";
	   }
	}
	
    @RequestMapping(path={"/impresion-factura-original"}, method=RequestMethod.GET)
	public void impresionFactura(HttpServletRequest request, HttpServletResponse response) {
        try {
        	Integer idComprobante=(Integer)request.getSession().getAttribute("idComprobante");
        	String sListaGuia=(String)request.getSession().getAttribute("p_lista_guia");
        	
        	if(idComprobante!=null&&idComprobante>0){
        		
        		//--generacion de codigo QR : INICIO
        		RegistroFacturaBo bo=new RegistroFacturaBo();
        		QRComprobante qrcomprobante=bo.obtenerQRComprobante(idComprobante);
     		    CodeQRWrite qr=new CodeQRWrite(qrcomprobante);
     		    
     		    String path=request.getServletContext().getRealPath("/");
     		   
     		    String pathQRImage=qr.writeQRCode(path);
     		    //--generacion de codigo QR : FIN
     		    
        		String jasperDir = "/jasper/";
                String realPathtoJasper =  request.getServletContext().getRealPath(jasperDir);
                System.out.println(realPathtoJasper);
                
            	JasperReport reporte = (JasperReport) JRLoader.loadObject(new File(realPathtoJasper+"/cab_comp_lav.jasper"));

                Map<String, Object> parametros = new HashMap<String, Object>();
                parametros.put("P_ID_COMPROBANTE",idComprobante);
                parametros.put("P_IMAGE_PATH",realPathtoJasper+"/logo.jpg");
                parametros.put("P_SUBREPORT_PATH",realPathtoJasper);
                parametros.put("P_LISTA_GUIA",sListaGuia);
                //parametros.put("P_QR_IMAGE_PATH", pathQRImage);
                parametros.put("P_QR_IMAGE_PATH",realPathtoJasper+"/logo.jpg");
                
                Connection conn = ConnectionFactory.getInstance().getConnection();
                
                JasperPrint jasperPrint = JasperFillManager.fillReport(reporte, parametros,conn);
                
                JRPdfExporter pdfExporter = new JRPdfExporter();
                pdfExporter.setExporterInput(new SimpleExporterInput(jasperPrint));
                ByteArrayOutputStream pdfReportStream = new ByteArrayOutputStream();
                pdfExporter.setExporterOutput(new SimpleOutputStreamExporterOutput(pdfReportStream));
                pdfExporter.exportReport();

                response.setContentType("application/pdf");
                response.setHeader("Content-Length", String.valueOf(pdfReportStream.size()));
                response.addHeader("Content-Disposition", "inline; filename=jasper.pdf;");

                OutputStream responseOutputStream = response.getOutputStream();
                responseOutputStream.write(pdfReportStream.toByteArray());
                responseOutputStream.close();
                pdfReportStream.close();
        	}
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
	
    
	@RequestMapping(path={"/impresion-boleta-original"}, method=RequestMethod.GET)
    public void  impresionBoleta(HttpServletRequest request, HttpServletResponse response) {
		 try {
	        	Integer idComprobante=(Integer)request.getSession().getAttribute("idComprobante");
	        	String sListaGuia=(String)request.getSession().getAttribute("p_lista_guia");
	        	if(idComprobante!=null&&idComprobante>0){
	        		
	        		String path=request.getServletContext().getRealPath("/");
	        		
	        		//--generacion de codigo QR : INICIO
	        		RegistroFacturaBo bo=new RegistroFacturaBo();
	        		QRComprobante qrcomprobante=bo.obtenerQRComprobante(idComprobante);
	     		    CodeQRWrite qr=new CodeQRWrite(qrcomprobante);
	     		    String pathQRImage=qr.writeQRCode(path);
	     		    //--generacion de codigo QR : FIN
	     		    
	        		String jasperDir = "/jasper/";
	                String realPathtoJasper =  request.getServletContext().getRealPath(jasperDir);
	                System.out.println(realPathtoJasper);
	                
	            	JasperReport reporte = (JasperReport) JRLoader.loadObject(new File(realPathtoJasper+"/cab_comp_lav.jasper"));

	                Map<String, Object> parametros = new HashMap<String, Object>();
	                parametros.put("P_ID_COMPROBANTE",idComprobante);
	                parametros.put("P_IMAGE_PATH",realPathtoJasper+"/logo.jpg");
	                parametros.put("P_SUBREPORT_PATH",realPathtoJasper);
	                parametros.put("P_LISTA_GUIA",sListaGuia);
	              //parametros.put("P_QR_IMAGE_PATH", pathQRImage);
	                parametros.put("P_QR_IMAGE_PATH",realPathtoJasper+"/logo.jpg");
	                
	                Connection conn = ConnectionFactory.getInstance().getConnection();
	                
	                JasperPrint jasperPrint = JasperFillManager.fillReport(reporte, parametros,conn);
	                
	                JRPdfExporter pdfExporter = new JRPdfExporter();
	                pdfExporter.setExporterInput(new SimpleExporterInput(jasperPrint));
	                ByteArrayOutputStream pdfReportStream = new ByteArrayOutputStream();
	                pdfExporter.setExporterOutput(new SimpleOutputStreamExporterOutput(pdfReportStream));
	                pdfExporter.exportReport();

	                response.setContentType("application/pdf");
	                response.setHeader("Content-Length", String.valueOf(pdfReportStream.size()));
	                response.addHeader("Content-Disposition", "inline; filename=jasper.pdf;");

	                OutputStream responseOutputStream = response.getOutputStream();
	                responseOutputStream.write(pdfReportStream.toByteArray());
	                responseOutputStream.close();
	                pdfReportStream.close();
	        	}
	        } catch (Exception e) {
	            e.printStackTrace();
	        }
	}
}
