package com.delfines.spring.controller;

import java.io.File;
import java.util.ArrayList;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;

import javax.servlet.http.HttpServletRequest;

import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.servlet.ModelAndView;

import com.delfines.Constante;
import com.delfines.business.ListaPrecioBo;
import com.delfines.business.RegistroLeadsBo;
import com.delfines.business.ServicioBo;
import com.delfines.vo.ErrorLead;
import com.delfines.vo.Lead;
import com.delfines.vo.LeadSeguimiento;
import com.delfines.vo.ListaPrecio;
import com.delfines.vo.Servicio;
import com.delfines.vo.Usuario;
import com.delfines.vo.Value;

/**
 * @author imssbora
 */
@Controller
public class RegistroLeadsController {
   
   @RequestMapping(path={"/lista-leads"},method=RequestMethod.GET)
   public String mostrarListaLeads(Model model,HttpServletRequest request) {
	    return "registro-leads-tabla";
   }
   
   
   @RequestMapping(path={"/asignar-ejecutivo-all"},method=RequestMethod.GET)
   @ResponseBody
   public ModelAndView asignarEjecutivoLeadsAll(Integer idEjecutivo,Model model,HttpServletRequest request) {
	   Usuario pUser=(Usuario)request.getSession().getAttribute("p_usuario");
	   
	   RegistroLeadsBo bo=new RegistroLeadsBo();
	   
	   List<Lead> listaLeads=(List<Lead>)request.getSession().getAttribute("listaLeads");
	   bo.asignarEjecutivo(idEjecutivo,listaLeads);
	   
	   //--Recuperalo desde la session
	   Integer idAdsetName=(Integer)request.getSession().getAttribute("idAdsetName");
	   String fechaAdsIni=(String)request.getSession().getAttribute("fechaAdsIni");
	   String fechaAdsFin=(String)request.getSession().getAttribute("fechaAdsFin");
	   Integer idArea=(Integer)request.getSession().getAttribute("idArea");
	   Integer idSubArea=(Integer)request.getSession().getAttribute("idSubArea");
	   
	   List<Lead> listaLeadsUpdate = getListLeads(idAdsetName,fechaAdsIni,fechaAdsFin,idArea,idSubArea,pUser);
	   
	   ModelAndView mv = new ModelAndView("registro-leads-tabla");
	   mv.addObject("listaLeads",listaLeadsUpdate);
	   return mv;
   }
   
   @RequestMapping(path={"/asignar-ejecutivo-single"},method=RequestMethod.GET)
   @ResponseBody
   public ModelAndView asignarEjecutivoLeadsSingle(Integer idEjecutivo,Integer idLead,Model model,HttpServletRequest request) {
	   Usuario pUser=(Usuario)request.getSession().getAttribute("p_usuario");
	   
	   RegistroLeadsBo bo=new RegistroLeadsBo();
	   bo.reAsignarEjecutivo(idEjecutivo, idLead);
	   
	   //--Recuperalo desde la session
	   Integer idAdsetName=(Integer)request.getSession().getAttribute("idAdsetName");
	   String fechaAdsIni=(String)request.getSession().getAttribute("fechaAdsIni");
	   String fechaAdsFin=(String)request.getSession().getAttribute("fechaAdsFin");
	   Integer idArea=(Integer)request.getSession().getAttribute("idArea");
	   Integer idSubArea=(Integer)request.getSession().getAttribute("idSubArea");
	   
	   List<Lead> listaLeadsUpdate = getListLeads(idAdsetName,fechaAdsIni,fechaAdsFin,idArea,idSubArea,pUser);
	   
	   ModelAndView mv = new ModelAndView("registro-leads-tabla");
	   mv.addObject("listaLeads",listaLeadsUpdate);
	   return mv;
   }
   
   
   @RequestMapping(path={"/buscar-leads"},method=RequestMethod.GET)
   @ResponseBody
   public ModelAndView buscarListaLeads(Integer idAdsetName,String fechaAdsIni,String fechaAdsFin,Integer idArea,Integer idSubArea,Model model,HttpServletRequest request) {
	   Usuario pUser=(Usuario)request.getSession().getAttribute("p_usuario");
	   
	   List<Lead> listaLeads = getListLeads(idAdsetName,fechaAdsIni,fechaAdsFin,idArea,idSubArea,pUser);
	   
	   request.getSession().setAttribute("idAdsetName", idAdsetName);
	   request.getSession().setAttribute("fechaAdsIni", fechaAdsIni);
	   request.getSession().setAttribute("fechaAdsFin", fechaAdsFin);
	   request.getSession().setAttribute("idArea", idArea);
	   request.getSession().setAttribute("idSubArea", idSubArea);
	   //--
	   
	   ModelAndView mv = new ModelAndView("registro-leads-tabla");
	   mv.addObject("listaLeads",listaLeads);
	   return mv;
   }
   
   @RequestMapping(path={"/buscar-leads-seguimiento"},method=RequestMethod.GET)
   @ResponseBody
   public ModelAndView buscarListaLeadsSeguimiento(Integer idLead,Model model,HttpServletRequest request) {
	   Usuario pUser=(Usuario)request.getSession().getAttribute("p_usuario");
	   
	   RegistroLeadsBo bo=new RegistroLeadsBo();
	   List<LeadSeguimiento> listaLeadSeguimiento=bo.listLeadsSeguimientoByIdLead(idLead);
	   	   
	   ModelAndView mv = new ModelAndView("registro-leads-tabla-seguimiento");
	   mv.addObject("listaLeadsSeguimiento",listaLeadSeguimiento);
	   return mv;
   }
   
   
   @RequestMapping(path={"/guardar-seguimiento"},method=RequestMethod.GET)
   @ResponseBody
   public ModelAndView guardarSeguimiento(Integer idEjecutivo,Integer idLead,Integer idCotizado,String fechaContacto,Integer idCanal,
			Integer idReserva,Integer idMotivo,String paxFinal,String revenue,String servicioFinal,
			Model model,HttpServletRequest request) {
	   Usuario pUser=(Usuario)request.getSession().getAttribute("p_usuario");
	   
	   RegistroLeadsBo bo=new RegistroLeadsBo();
	   Integer result=bo.guardarSeguimiento(idEjecutivo,idLead,idCotizado,fechaContacto,idCanal,
				idReserva,idMotivo,paxFinal,revenue,servicioFinal,pUser);
	   
	   //--Recuperalo desde la session
	   Integer idAdsetName=(Integer)request.getSession().getAttribute("idAdsetName");
	   String fechaAdsIni=(String)request.getSession().getAttribute("fechaAdsIni");
	   String fechaAdsFin=(String)request.getSession().getAttribute("fechaAdsFin");
	   Integer idArea=(Integer)request.getSession().getAttribute("idArea");
	   Integer idSubArea=(Integer)request.getSession().getAttribute("idSubArea");
	   
	   List<Lead> listaLeadsUpdate = getListLeads(idAdsetName,fechaAdsIni,fechaAdsFin,idArea,idSubArea,pUser);
	   
	   ModelAndView mv = new ModelAndView("registro-leads-tabla");
	   mv.addObject("listaLeads",listaLeadsUpdate);
	   return mv;
   }
   
   
   public  List<Lead> getListLeads(Integer idAdsetName,String fechaAdsIni,String fechaAdsFin,Integer idArea,Integer idSubArea,Usuario pUser){
	   List<Lead> listaLeads = new ArrayList<Lead>();
	   RegistroLeadsBo bo=new RegistroLeadsBo();
	   
	   if(idAdsetName!=null && idAdsetName>0){
		   listaLeads=bo.listLeadsByIdAdSetName(idAdsetName, pUser);		   
	   }else if(fechaAdsIni!=null&&fechaAdsIni.trim().length()>0&&
			   fechaAdsFin!=null&&fechaAdsFin.trim().length()>0){
		   listaLeads=bo.listLeadsByFechaAdSet(fechaAdsIni,fechaAdsFin, pUser);
	   }else if(idArea!=null && idArea>0&&
			   idSubArea!=null && idSubArea>0){
		   listaLeads=bo.listLeadsByIdArea(idArea,idSubArea, pUser);
	   }
	   
	   return listaLeads;
   }
   
   /**
    * Registro leads
    * @param model
    * @param request
    * @return
    */
   @RequestMapping(path={"/registro-leads"},method=RequestMethod.GET)
   public String  registrLeads(Model model,HttpServletRequest request) {
	   Usuario pUsuario=(Usuario)request.getSession().getAttribute("p_usuario");
	   if(pUsuario!=null&&pUsuario.getUsuarioId()>0){
		   
		   
		   
		   RegistroLeadsBo bo=new RegistroLeadsBo();
		   List<Value> listaAdSetName=bo.listAdSetName();
		   List<Value> listaArea=bo.listArea();
		   List<Value> listaSubArea=bo.listSubArea();
		   List<Value> listaEjecutivo=bo.listEjecutivo();
		   
		   String fechaHoy=bo.getDate();
		   
		   model.addAttribute("listaAdSetName", listaAdSetName);
		   model.addAttribute("listaArea", listaArea);
		   model.addAttribute("listaSubArea", listaSubArea);
		   model.addAttribute("listaEjecutivo", listaEjecutivo);
		   model.addAttribute("fechaHoy", fechaHoy);
		   
		   return "registro-leads";
	   }else{
		   return "login";
	   }
   }
   
   @RequestMapping(path={"/registro-leads-tabla"},method=RequestMethod.GET)
   public String  registrLeadsTabla(Model model,HttpServletRequest request) {
	   Usuario pUsuario=(Usuario)request.getSession().getAttribute("p_usuario");
	   if(pUsuario!=null&&pUsuario.getUsuarioId()>0){
		   return "registro-leads-tabla";
	   }else{
		   return "login";
	   }
   }
   
}
