package com.delfines.spring.controller;

import java.util.ArrayList;
import java.util.LinkedList;
import java.util.List;

import javax.servlet.http.HttpServletRequest;

import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.servlet.ModelAndView;

import com.delfines.Constante;
import com.delfines.business.ClienteBo;
import com.delfines.business.RegistroFacturaBo;
import com.delfines.business.RegistroGuiaBo;
import com.delfines.business.RegistroPagoBo;
import com.delfines.business.ReportesBo;
import com.delfines.business.ServicioBo;
import com.delfines.business.UsuarioBo;
import com.delfines.vo.Cliente;
import com.delfines.vo.Comprobante;
import com.delfines.vo.ComprobanteDetalle;
import com.delfines.vo.ConsultaEstadoOrdenes;
import com.delfines.vo.ConsultaPagos;
import com.delfines.vo.Guia;
import com.delfines.vo.GuiaDetalle;
import com.delfines.vo.Servicio;
import com.delfines.vo.Usuario;

/**
 * @author imssbora
 */
@Controller
public class ReporteEstadoOrdenesController {
   
	@RequestMapping(path={"/consulta-reporte-estado-ordenes"}, method=RequestMethod.GET)
	public ModelAndView  consultaReporteEstadoOrdenes(String fechaGuiaIni,String fechaGuiaFin,Integer idListaPrecio,Integer estadoEntrega,Model model,HttpServletRequest request) {
	   ReportesBo bo=new ReportesBo();
	   List<ConsultaEstadoOrdenes> lista=new ArrayList<ConsultaEstadoOrdenes>();
		   
	   if(fechaGuiaIni.trim().length()>0 && fechaGuiaFin.trim().length()>0 ){
		   lista=bo.buscarReporteEstadoOrdenesByFechaGuia(fechaGuiaIni, fechaGuiaFin,idListaPrecio,estadoEntrega);
	   }
	   
	   ModelAndView mv = new ModelAndView("reporte-estado-ordenes-tabla");
       mv.addObject("lista",lista);
       return mv;
	}
	
}
