package com.delfines.spring.controller;

import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.OutputStream;
import java.sql.Connection;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.servlet.ModelAndView;

import com.delfines.business.ReportesBo;
import com.delfines.dao.ConnectionFactory;
import com.delfines.vo.ConsultaDetalleOrdenes;
import com.delfines.vo.ConsultaPagos;
import com.delfines.vo.RegistroInventario;
import com.delfines.vo.RegistroVenta;
import com.delfines.vo.Usuario;

import net.sf.jasperreports.engine.DefaultJasperReportsContext;
import net.sf.jasperreports.engine.JRPropertiesUtil;
import net.sf.jasperreports.engine.JasperFillManager;
import net.sf.jasperreports.engine.JasperPrint;
import net.sf.jasperreports.engine.JasperReport;
import net.sf.jasperreports.engine.export.JRPdfExporter;
import net.sf.jasperreports.engine.util.JRLoader;
import net.sf.jasperreports.export.SimpleExporterInput;
import net.sf.jasperreports.export.SimpleOutputStreamExporterOutput;

/**
 * @author imssbora
 */
@Controller
public class ReporteInventariosController {
   
	@RequestMapping(path={"/consulta-reporte-inventarios"}, method=RequestMethod.GET)
	public ModelAndView  consultaReporteVentas(String fechaIni,String fechaFin,Model model,HttpServletRequest request) {
	   ReportesBo bo=new ReportesBo();
	   List<RegistroInventario> lista=new ArrayList<RegistroInventario>();
		   
	   if(fechaIni.trim().length()>0 && fechaFin.trim().length()>0 ){
		   lista=bo.reporteRegistroInventario(fechaIni, fechaFin);
	   }
	   
	   request.getSession().setAttribute("p_fechaIni",fechaIni);
	   request.getSession().setAttribute("p_fechaFin",fechaFin);
	   
	   ModelAndView mv = new ModelAndView("reporte-inventario-tabla");
       mv.addObject("lista",lista);
       return mv;
	}
	
}

