package com.delfines.spring.controller;

import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.OutputStream;
import java.sql.Connection;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.servlet.ModelAndView;

import com.delfines.business.ReportesBo;
import com.delfines.dao.ConnectionFactory;
import com.delfines.vo.ConsultaPagos;
import com.delfines.vo.Usuario;

import net.sf.jasperreports.engine.DefaultJasperReportsContext;
import net.sf.jasperreports.engine.JRPropertiesUtil;
import net.sf.jasperreports.engine.JasperFillManager;
import net.sf.jasperreports.engine.JasperPrint;
import net.sf.jasperreports.engine.JasperReport;
import net.sf.jasperreports.engine.export.JRPdfExporter;
import net.sf.jasperreports.engine.util.JRLoader;
import net.sf.jasperreports.export.SimpleExporterInput;
import net.sf.jasperreports.export.SimpleOutputStreamExporterOutput;

/**
 * @author imssbora
 */
@Controller
public class ReportePagosController {
   
	@RequestMapping(value="/print-comp-pago", method=RequestMethod.GET)
    @ResponseBody
    public Integer printGuia(Integer idComprobantePago,Model model,HttpServletRequest request) {
	   Usuario pUsuario=(Usuario)request.getSession().getAttribute("p_usuario");
	   request.getSession().setAttribute("p_idComprobantePago",idComprobantePago);
	   return 0;
    }
	
	@RequestMapping(path={"/impresion-factura-pago"}, method=RequestMethod.GET)
	public void impresionFactura(HttpServletRequest request, HttpServletResponse response) {
        try {
        	Integer idComprobante=(Integer)request.getSession().getAttribute("p_idComprobantePago");
        	
        	if(idComprobante!=null&&idComprobante>0){
        		//--generacion de codigo QR : INICIO
        		/*
        		String path=request.getServletContext().getRealPath("/");
        		System.out.println(path);
        		
        		RegistroFacturaBo bo=new RegistroFacturaBo();
        		QRComprobante qrcomprobante=bo.obtenerQRComprobante(idComprobante);
     		    CodeQRWrite qr=new CodeQRWrite(qrcomprobante);
     		    String pathQRImage=qr.writeQRCode(path);
     		    */
     		    //--generacion de codigo QR : FIN
     		    
        		String jasperDir = "/jasper/";
                String realPathtoJasper =  request.getServletContext().getRealPath(jasperDir);
                //System.out.println(realPathtoJasper);
                
                final String fontePadrao = "SansSerif";
                final DefaultJasperReportsContext contexto = DefaultJasperReportsContext.getInstance();
                JRPropertiesUtil.getInstance(contexto).setProperty("net.sf.jasperreports.awt.ignore.missing.font", "true");
                JRPropertiesUtil.getInstance(contexto).setProperty("net.sf.jasperreports.default.font.name", fontePadrao);
                
            	JasperReport reporte = (JasperReport) JRLoader.loadObject(new File(realPathtoJasper+"/cab_comp_lav.jasper"));
            	
                Map<String, Object> parametros = new HashMap<String, Object>();
                parametros.put("P_ID_COMPROBANTE",idComprobante);
                parametros.put("P_IMAGE_PATH",realPathtoJasper+"/logo.jpg");
                parametros.put("P_SUBREPORT_PATH",realPathtoJasper+"/");
                parametros.put("P_LISTA_GUIA","1,2");
                parametros.put("P_QR_IMAGE_PATH", realPathtoJasper+"/3640.png");
                //parametros.put("P_QR_IMAGE_PATH",realPathtoJasper+"/logo.jpg");
                
                Connection conn = ConnectionFactory.getInstance().getConnection();
                
                JasperPrint jasperPrint = JasperFillManager.fillReport(reporte, parametros,conn);
                
                JRPdfExporter pdfExporter = new JRPdfExporter();
                pdfExporter.setExporterInput(new SimpleExporterInput(jasperPrint));
                ByteArrayOutputStream pdfReportStream = new ByteArrayOutputStream();
                pdfExporter.setExporterOutput(new SimpleOutputStreamExporterOutput(pdfReportStream));
                pdfExporter.exportReport();

                response.setContentType("application/pdf");
                response.setHeader("Content-Length", String.valueOf(pdfReportStream.size()));
                response.addHeader("Content-Disposition", "inline; filename=jasper.pdf;");

                OutputStream responseOutputStream = response.getOutputStream();
                responseOutputStream.write(pdfReportStream.toByteArray());
                responseOutputStream.close();
                pdfReportStream.close();
        	}
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
	
    
	@RequestMapping(path={"/impresion-boleta-pago"}, method=RequestMethod.GET)
    public void  impresionBoleta(HttpServletRequest request, HttpServletResponse response) {
		 try {
	        	Integer idComprobante=(Integer)request.getSession().getAttribute("p_idComprobantePago");
	        	String sListaGuia="";
	        	if(idComprobante!=null&&idComprobante>0){
	        		
	        		//--generacion de codigo QR : INICIO
	        		/*
	        		String path=request.getServletContext().getRealPath("/");
	        		System.out.println(path);
	        		
	        		RegistroFacturaBo bo=new RegistroFacturaBo();
	        		QRComprobante qrcomprobante=bo.obtenerQRComprobante(idComprobante);
	     		    CodeQRWrite qr=new CodeQRWrite(qrcomprobante);
	     		    String pathQRImage=qr.writeQRCode(path);
	     		    */
	     		    //--generacion de codigo QR : FIN
	     		    
	        		String jasperDir = "/jasper/";
	                String realPathtoJasper =  request.getServletContext().getRealPath(jasperDir);
	               // System.out.println(realPathtoJasper);
	                
	                final String fontePadrao = "SansSerif";
	                final DefaultJasperReportsContext contexto = DefaultJasperReportsContext.getInstance();
	                JRPropertiesUtil.getInstance(contexto).setProperty("net.sf.jasperreports.awt.ignore.missing.font", "true");
	                JRPropertiesUtil.getInstance(contexto).setProperty("net.sf.jasperreports.default.font.name", fontePadrao);
	                
	            	JasperReport reporte = (JasperReport) JRLoader.loadObject(new File(realPathtoJasper+"/cab_comp_lav.jasper"));

	                Map<String, Object> parametros = new HashMap<String, Object>();
	                parametros.put("P_ID_COMPROBANTE",idComprobante);
	                parametros.put("P_IMAGE_PATH",realPathtoJasper+"/logo.jpg");
	                parametros.put("P_SUBREPORT_PATH",realPathtoJasper+"/");
	                parametros.put("P_LISTA_GUIA","1");
	                parametros.put("P_QR_IMAGE_PATH", realPathtoJasper+"/3640.png");
	                //parametros.put("P_QR_IMAGE_PATH",realPathtoJasper+"/logo.jpg");
	                
	                Connection conn = ConnectionFactory.getInstance().getConnection();
	                
	                JasperPrint jasperPrint = JasperFillManager.fillReport(reporte, parametros,conn);
	                
	                JRPdfExporter pdfExporter = new JRPdfExporter();
	                pdfExporter.setExporterInput(new SimpleExporterInput(jasperPrint));
	                ByteArrayOutputStream pdfReportStream = new ByteArrayOutputStream();
	                pdfExporter.setExporterOutput(new SimpleOutputStreamExporterOutput(pdfReportStream));
	                pdfExporter.exportReport();

	                response.setContentType("application/pdf");
	                response.setHeader("Content-Length", String.valueOf(pdfReportStream.size()));
	                response.addHeader("Content-Disposition", "inline; filename=jasper.pdf;");

	                OutputStream responseOutputStream = response.getOutputStream();
	                responseOutputStream.write(pdfReportStream.toByteArray());
	                responseOutputStream.close();
	                pdfReportStream.close();
	        	}
	        } catch (Exception e) {
	            e.printStackTrace();
	        }
	}
	
	
	@RequestMapping(path={"/consulta-reporte-pagos"}, method=RequestMethod.GET)
	public ModelAndView  consultaReportePagos(String fechaGuiaIni,String fechaGuiaFin,Integer idFormaPago,Model model,HttpServletRequest request) {
	   ReportesBo bo=new ReportesBo();
	   List<ConsultaPagos> lista=new ArrayList<ConsultaPagos>();
		   
	   if(fechaGuiaIni.trim().length()>0 && fechaGuiaFin.trim().length()>0 ){
		   lista=bo.buscarReportePagosByFechaGuia(fechaGuiaIni, fechaGuiaFin,0,idFormaPago);
	   }
	   
	   request.getSession().setAttribute("p_fechaGuiaIni",fechaGuiaIni);
	   request.getSession().setAttribute("p_fechaGuiaFin",fechaGuiaFin);
	   request.getSession().setAttribute("p_idFormaPago",idFormaPago);
	   
	   ModelAndView mv = new ModelAndView("reporte-pagos-tabla");
       mv.addObject("lista",lista);
       return mv;
	}
	
	@RequestMapping(path={"/impresion-reporte-pagos"}, method=RequestMethod.GET)
	public void  consultaReportePagos(HttpServletRequest request, HttpServletResponse response) {
	    
		try {
			String fechaGuiaIni=(String)request.getSession().getAttribute("p_fechaGuiaIni");
			String fechaGuiaFin=(String)request.getSession().getAttribute("p_fechaGuiaFin");
			Integer idFormaPago=(Integer)request.getSession().getAttribute("p_idFormaPago");
			
        	if(fechaGuiaIni!=null&&fechaGuiaFin!=null){
        		String jasperDir = "/jasper/";
                String realPathtoJasper =  request.getServletContext().getRealPath(jasperDir);
                System.out.println(realPathtoJasper);
                
            	JasperReport reporte = (JasperReport) JRLoader.loadObject(new File(realPathtoJasper+"/reporte_pago_lav.jasper"));

                Map<String, Object> parametros = new HashMap<String, Object>();
                parametros.put("P_IMAGE_PATH",realPathtoJasper+"/logo.jpg");
                
                parametros.put("P_FECHA_INICIO",fechaGuiaIni);
                parametros.put("P_FECHA_FIN",fechaGuiaFin);
                parametros.put("P_FORMA_PAGO",idFormaPago);
                
                Connection conn = ConnectionFactory.getInstance().getConnection();
                
                JasperPrint jasperPrint = JasperFillManager.fillReport(reporte, parametros,conn);
                
                JRPdfExporter pdfExporter = new JRPdfExporter();
                pdfExporter.setExporterInput(new SimpleExporterInput(jasperPrint));
                ByteArrayOutputStream pdfReportStream = new ByteArrayOutputStream();
                pdfExporter.setExporterOutput(new SimpleOutputStreamExporterOutput(pdfReportStream));
                pdfExporter.exportReport();

                response.setContentType("application/pdf");
                response.setHeader("Content-Length", String.valueOf(pdfReportStream.size()));
                response.addHeader("Content-Disposition", "inline; filename=reporte_pago_lav.pdf;");

                OutputStream responseOutputStream = response.getOutputStream();
                responseOutputStream.write(pdfReportStream.toByteArray());
                responseOutputStream.close();
                pdfReportStream.close();
        	}
        } catch (Exception e) {
            e.printStackTrace();
        }
		
	}
	
	
	
	
	
}
