package com.delfines.spring.controller;

import java.util.LinkedList;
import java.util.List;

import javax.servlet.http.HttpServletRequest;

import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.servlet.ModelAndView;

import com.delfines.Constante;
import com.delfines.business.ServicioBo;
import com.delfines.vo.Servicio;
import com.delfines.vo.Usuario;

/**
 * @author imssbora
 */
@Controller
public class TipoCambioController {
   
   @RequestMapping(path={"/lista-tipo-cambio"},method=RequestMethod.GET)
   public ModelAndView listaTipoCambio(Model model,HttpServletRequest request) {
	    ServicioBo servicio=new ServicioBo();
	    List lTipoCambio=servicio.listaTipoCambio();
	   
		ModelAndView mv = new ModelAndView("mante-tipo-cambio-tabla");
		mv.addObject("lTipoCambio",lTipoCambio);
		return mv;
   }
   
   @RequestMapping(path={"/registro-tipo-cambio"},method=RequestMethod.GET)
   public ModelAndView registroTipoCambio(Integer idTipoCambio,String fecha,Double tipoCambioCompra,Double tipoCambioVenta,Model model,HttpServletRequest request) {
	    Integer res=Constante.ID_INICIAL; 
	    ServicioBo servicio=new ServicioBo();
	    Usuario pUsuario=(Usuario)request.getSession().getAttribute("p_usuario");
	    
	    String msg="";
	    if(idTipoCambio>0){
	    	res=servicio.actualizaTipoCambio(idTipoCambio, tipoCambioCompra, tipoCambioVenta, fecha, pUsuario);
	    }else{
	    	Integer cantidad=servicio.validaTipoCambio(fecha);
	    	if(cantidad<=0){
	    		res=servicio.registraTipoCambio(fecha, tipoCambioCompra, tipoCambioVenta, pUsuario);	
	    	}else{
	    		msg="El tipo de cambio con fecha "+fecha+" existe, porfavor verificar !";
	    	}
	    }
	    List lTipoCambio=servicio.listaTipoCambio();	
	    
		ModelAndView mv = new ModelAndView("mante-tipo-cambio-tabla");
		mv.addObject("lTipoCambio",lTipoCambio);
		mv.addObject("msg",msg);
		return mv;
   }
   
   @RequestMapping(path={"/eliminar-tipo-cambio"},method=RequestMethod.GET)
   public ModelAndView eliminarServicio(Integer idTipoCambio,Model model,HttpServletRequest request) {
	    Integer res=Constante.ID_INICIAL; 
	    ServicioBo servicio=new ServicioBo();
	    Usuario pUsuario=(Usuario)request.getSession().getAttribute("p_usuario");
	    if(idTipoCambio>0){
	    	res=servicio.eliminarTipoCambio(idTipoCambio, pUsuario);
	    }
	    
	    List lTipoCambio=new LinkedList<Servicio>();
	    if(res>0){
	    	lTipoCambio=servicio.listaTipoCambio();	
	    }
		ModelAndView mv = new ModelAndView("mante-tipo-cambio-tabla");
		mv.addObject("lTipoCambio",lTipoCambio);
		return mv;
   }
   
   
}
