package com.delfines.spring.controller;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.net.URL;
import java.util.HashMap;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;

import com.delfines.business.ClienteBo;
import com.delfines.business.ServicioBatchBo;
import com.delfines.business.ServicioBo;
import com.delfines.vo.TipoCambioDia;
import com.delfines.vo.Usuario;

public class TipoCambioSUNAT {
	
	HashMap<Integer, TipoCambioDia> htipocambio=null;
	
	public TipoCambioSUNAT(){
		htipocambio=new HashMap<Integer, TipoCambioDia>();
	}
	
	public static void main(String[] args) {
		
		try{
   			ServicioBatchBo bo=new ServicioBatchBo();
   			String fechaActual=bo.getDate();
        	Integer diaActual=bo.getDay();
        	
        	System.out.println("INICIA REGISTRO DE TIPOS DE CAMBIO : "+fechaActual);
        	
   			TipoCambioSUNAT tp=new TipoCambioSUNAT();
   			
   			TipoCambioDia base=bo.getBaseTipoCambio();
   			tp.setBase(base);
   			
   			tp.load();
   			TipoCambioDia val=tp.getTipoCambio(diaActual);
   			
   			bo.registraTipoCambio(fechaActual, val.getCompra(), val.getVenta(), new Usuario());
   			
   			System.out.println("FINALIZA REGISTRO DE TIPOS DE CAMBIO : "+val.getCompra()+" / "+val.getVenta());
   			
	    }catch(Exception e){
	    	e.printStackTrace();
	    }
		
	}
	
	public void setBase(TipoCambioDia base) {
		try{
			htipocambio.put(base.getDia(), base);
		}catch(Exception e){
			e.printStackTrace();
		}
	}
	
	public void load() {
    	try{
    		URL oracle = new URL("http://www.sunat.gob.pe/cl-at-ittipcam/tcS01Alias");
	        BufferedReader in = new BufferedReader(
	        new InputStreamReader(oracle.openStream()));

	        List<String> lista=new LinkedList<>();
	        
	        String inputLine;
	        while ((inputLine = in.readLine()) != null){
	        	String line=inputLine.replace("\"", "\'");
	        	
	        	if(line.trim().equals("<td width='4%' align='center' class='H3'>")){
	        		if((inputLine = in.readLine())!=null){
	        			lista.add(inputLine.trim());	
	        		}
	        	}
	        	
	        	if(line.trim().equals("<td width='8%' align='center' class='tne10'>")){
	        		if((inputLine = in.readLine())!=null){
	        			lista.add(inputLine.trim());	
	        		}
	        	}
	        	
	        }
	        in.close();
	        
	        Iterator<String> it = lista.iterator();
	        while (it.hasNext()) {
	        	String dato=it.next();
	        	
	        	Integer pk=new Integer(0);
	        	TipoCambioDia hvalue=new TipoCambioDia();
	        	
	        	if(dato.contains("<strong>")){
	        		String dia=dato.replaceAll("<strong>", "").replace("</strong>", "");
	        		
	        		pk=getDay(dia);
	        		hvalue.setDia(pk);
	        		
	        		if(it.hasNext()){
	        			String compra=it.next();
	        			hvalue.setCompra(getValue(compra));
	        		}
	        		
	        		if(it.hasNext()){
	        			String venta=it.next();
	        			hvalue.setVenta(getValue(venta));
	        		}
	        	}
	        	
	        	htipocambio.put(pk, hvalue);
			}
	        
    	}catch(Exception e){
    		e.printStackTrace();
    	}
    }
	
	public TipoCambioDia getTipoCambio(Integer day){
		
		TipoCambioDia value=null;
		while((value=htipocambio.get(day))==null){
			day--;
		}
		
		return value;
	}
	
	private Integer getDay(String day){
		Integer iday=new Integer(0);
		try{
			iday=Integer.valueOf(day);
		}catch(Exception e){
			e.printStackTrace();
		}
		return iday;
	}
	
	private Double getValue(String value){
		Double dvalue=new Double(0.0);
		try{
			dvalue=Double.valueOf(value);
		}catch(Exception e){
			e.printStackTrace();
		}
		return dvalue;
	}
	
}