package com.delfines.spring.controller;

import java.util.List;

import javax.servlet.http.HttpServletRequest;

import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.servlet.ModelAndView;

import com.delfines.Constante;
import com.delfines.Empresa;
import com.delfines.business.ClienteBo;
import com.delfines.business.UsuarioBo;
import com.delfines.vo.Usuario;

/**
 * @author imssbora
 */
@Controller
public class UsuarioController {
   
   private UsuarioBo usuarioBo=new UsuarioBo(); 

   @RequestMapping(path={"/login-usuario"},method=RequestMethod.GET)
   public ModelAndView loginUsuario(String username,String passwd,Model model,HttpServletRequest request)throws Exception {
	   Usuario usuario=usuarioBo.loginUsuario(username,passwd);

	   ModelAndView mav = new ModelAndView();
	
	   if(usuario!=null&&usuario.getUsuarioId()>0){
		   request.getSession().setAttribute("p_usuario",usuario);
		   mav.setViewName("registro-comp");
		   mav.addObject("done", "1");
		   
		   Empresa.getInstance().ID_EMPRESA=usuario.getIdEmpresa();
		   
	   }else{
		   throw new Exception("Usuario no registrado o Password incorrecto");
	   }
       return mav;
   }

   @RequestMapping(path={"/add-user"},method=RequestMethod.GET)
   public ModelAndView addUsuario(Model model,HttpServletRequest request)throws Exception {
	   ModelAndView mav = new ModelAndView();

	   mav.setViewName("adduser");
	   
       return mav;
   }
   
   //registro-usuario
   @RequestMapping(path={"/registro-usuario"},method=RequestMethod.GET)
   public ModelAndView registroUsuario(String username,
		   String passwd1,String passwd2,Model model,HttpServletRequest request)throws Exception {
	   
	   ModelAndView mav = new ModelAndView();
	   
	   if(passwd1!=null&&passwd1.trim().length()>0&&
			   passwd2!=null&&passwd2.trim().length()>0&&
					   passwd1.trim().length()==passwd2.trim().length()&&
			   passwd1.equals(passwd2)){
		   
		    Integer cantidad=usuarioBo.validaUsername(username);
	    	if(cantidad<=0){
	    		Integer idEmpresa=usuarioBo.registraEmpresa(username,username,passwd1);
	    		if(idEmpresa>Constante.ID_INICIAL){
	    			
	    			Integer idUsuario=usuarioBo.registraUsuario(username,passwd1,idEmpresa);
	    			
	    			if(idUsuario>Constante.ID_INICIAL){
		 	    	    Usuario usuario=usuarioBo.loginUsuario(username,passwd1);
		 	 		    if(usuario!=null&&usuario.getUsuarioId()>0){
		 	 			   request.getSession().setAttribute("p_usuario",usuario);
		 	 			   mav.setViewName("registro-comp");
		 	 			   mav.addObject("done", "1");
		 	 			   
		 	 			   Empresa.getInstance().ID_EMPRESA=usuario.getIdEmpresa();
		 	 		    }else{
		 	 			   throw new Exception("Usuario no registrado o Password incorrecto");
		 	 		    }
	    			}else{
	    				throw new Exception("Usuario no registrado o Password incorrecto");
	    			}
	 	    	}else{
	 	    		throw new Exception("Usuario no registrado o Password incorrecto");
	 	    	}
	    	}else{
	    		throw new Exception("Existe el registro de usuario "+username+", porfavor verificar !");
	    	}
	    	
	   }else{
		   throw new Exception("El password no coincide con la confirmacin");
	   }
	   return mav;
	   
   }
   
}
