package com.org.ws;

import java.io.File;
import java.util.Calendar;
import java.util.Date;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;

import org.w3c.dom.Document;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

import com.delfines.business.ClienteBo;
import com.delfines.business.RegistroGosocketBo;

/**
 * Conversion del xml ubl 2.0 a xml ubl 2.1 para micros 9700 HMS
 * @author master
 */
public class ParseUBL21Xml {

	public static void main(String argv[]) {
    	ParseUBL21Xml t =new ParseUBL21Xml();
    	
    	// Choose time zone in which you want to interpret your Date
    	Calendar cal = Calendar.getInstance();
    	cal.add(Calendar.DATE, -1);
    	
    	int year = cal.get(Calendar.YEAR);
    	int month = cal.get(Calendar.MONTH)+1;
    	int day = cal.get(Calendar.DAY_OF_MONTH);
    	
    	String sYear=String.format("%04d", year); 
    	String sMonth=String.format("%02d", month);
    	String sDay=String.format("%02d", day);
    	
    	StringBuilder spath = new StringBuilder();
    	spath.append("\\\\10.0.0.127\\c$\\Program Files (x86)\\Signature\\xDoc PE 2.1\\Stores\\areas\\PD21-DLFOPERA\\bkp\\_xml-firmado\\").append(sYear).append("\\").append(sMonth).append("\\").append(sDay);
    	//spath.append("\\\\10.0.0.127\\c$\\Program Files (x86)\\Signature\\xDoc PE 2.1\\Stores\\areas\\PD21-DLFOPERA\\bkp\\_xml-firmado\\2020\\07\\31");
    	//spath.append("\\\\10.0.0.11\\De Paso\\Agent\\signature");
    	
    	String _PATH=spath.toString();
    	System.out.println(_PATH);
    	
    	File folder = new File(_PATH);
    	File[] listOfFiles = folder.listFiles();

    	for (File file : listOfFiles) {
    	    if (file.isFile()) {
    	        String pathfile=_PATH+"\\"+file.getName();
    	        t.parse(pathfile);
    	    }
    	}
    	
    	
    	System.out.println("end ...");
    }
	
    public void parse(String xmlPathFile){
    	try {
    		
    		String nroComprobante="";
    		String fechaComprobante="";
    		String tipoComprobante="";
    		String montoComprobante="";
    		String nroDocumento="";
    		String tipoDocumento="";
    		String tipoMoneda="";
    		
    		String nombreCliente="";
    		
            File xmlFile = new File(xmlPathFile);
 
            DocumentBuilderFactory documentBuilderFactory = DocumentBuilderFactory.newInstance();
 
            DocumentBuilder documentBuilder = documentBuilderFactory.newDocumentBuilder();
 
            Document doc = documentBuilder.parse(xmlFile);
 
            doc.getDocumentElement().normalize();
 
            Node invoice = doc.getElementsByTagName("Invoice").item(0);
            
            NodeList nodesinvoice = invoice.getChildNodes();
            if (nodesinvoice != null) {
            	for(int j=0;j<nodesinvoice.getLength();j++){
            		Node childTaxTotal = nodesinvoice.item(j);
            		if(childTaxTotal.getNodeName().equals("cbc:ID")){
            			nroComprobante=childTaxTotal.getTextContent();
            		}
            		if(childTaxTotal.getNodeName().equals("cbc:IssueDate")){
            			fechaComprobante=childTaxTotal.getTextContent();
            		}
            		if(childTaxTotal.getNodeName().equals("cbc:InvoiceTypeCode")){
            			tipoComprobante=childTaxTotal.getTextContent();
            		}
            		if(childTaxTotal.getNodeName().equals("cbc:DocumentCurrencyCode")){
            			tipoMoneda=childTaxTotal.getTextContent();
            		}
            	}
            }
            
            Node additionalInformation = doc.getElementsByTagName("cac:AccountingCustomerParty").item(0);
            
            NodeList nodesTaxSubTotal = additionalInformation.getChildNodes();
            if (nodesTaxSubTotal != null) {
            	for(int j=0;j<nodesTaxSubTotal.getLength();j++){
            		Node childTaxTotal = nodesTaxSubTotal.item(j);
            		if(childTaxTotal.getNodeName().equals("cbc:CustomerAssignedAccountID")){
            			nroDocumento=childTaxTotal.getTextContent();
            		}
            		if(childTaxTotal.getNodeName().equals("cbc:AdditionalAccountID")){
            			tipoDocumento=childTaxTotal.getTextContent();
            		}
            		if(childTaxTotal.getNodeName().equals("cac:Party")){
            			NodeList nodesParty = childTaxTotal.getChildNodes();
            			for(int p=0;p<nodesParty.getLength();p++){
            				Node childParty = nodesParty.item(p);
            				if(childParty.getNodeName().equals("cac:PartyName")){
            					NodeList nodesPartyName = childParty.getChildNodes();
                    			for(int r=0;r<nodesPartyName.getLength();r++){
                    				Node childPartyName = nodesPartyName.item(r);
                    				if(childPartyName.getNodeName().equals("cbc:Name")){
                    					nombreCliente=childPartyName.getTextContent().toUpperCase();
                            		}
                    			}
                    		}
            			}
            		}
            	}
            }
            
            Node LegalMonetaryTotal = doc.getElementsByTagName("cac:LegalMonetaryTotal").item(0);
            
            NodeList nodesLegalMonetaryTotal = LegalMonetaryTotal.getChildNodes();
            if (nodesLegalMonetaryTotal != null) {
            	for(int j=0;j<nodesLegalMonetaryTotal.getLength();j++){
            		Node childTaxTotal = nodesLegalMonetaryTotal.item(j);
            		if(childTaxTotal.getNodeName().equals("cbc:PayableAmount")){
            			montoComprobante=childTaxTotal.getTextContent();
            		}
            	}
            }
            
            RegistroGosocketBo bo=new RegistroGosocketBo();
            bo.registroGosocket(nroComprobante, fechaComprobante, tipoComprobante, montoComprobante, nroDocumento, tipoDocumento, nombreCliente, tipoMoneda);
            
            //ClienteBo bo=new ClienteBo();
            //bo.registroGosocket(nroComprobante, fechaComprobante, tipoComprobante, montoComprobante, nroDocumento, tipoDocumento,nombreCliente,tipoMoneda);
            //System.out.println(Util.format(montoComprobante));
            
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
	
}
