/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package genfactura;

import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import com.delfines.Constante;
import com.delfines.ConstanteSUNAT;
import com.delfines.vo.Comprobante;
import com.delfines.vo.ComprobanteDetalle;
import com.org.model.beans.DocumentoCabBean;
import com.org.model.beans.DocumentodetBean;
import com.org.model.beans.Leyenda;
import com.org.ws.BolElectronicaIng;


public class GenFacturaIng {

	private String dataDirectory;
	
	public  GenFacturaIng(String dataDirectory){
		this.dataDirectory=dataDirectory;
	}
	
    public Integer enviarComprobanteToSunat(Comprobante cabecera,List<ComprobanteDetalle> lDetalle){
    	DocumentoCabBean items = new DocumentoCabBean();
    	// Empresa o emisor
        items.setEmpr_tipodoc(ConstanteSUNAT.TIPO_DOCUMENTO_RUC);
        items.setEmpr_nroruc(ConstanteSUNAT.EMPRESA_RUC);
        items.setEmpr_razonsocial(ConstanteSUNAT.EMPRESA_RAZSOC);
        items.setEmpr_nombrecomercial(ConstanteSUNAT.EMPRESA_DENOCOM);
        items.setEmpr_direccion(ConstanteSUNAT.EMPRESA_DIRECCION);
        items.setEmpr_distrito(ConstanteSUNAT.EMPRESA_DISTRITO);
        items.setEmpr_provincia(ConstanteSUNAT.EMPRESA_PROVINCIA);
        items.setEmpr_departamento(ConstanteSUNAT.EMPRESA_DEPARTAMENTO);
        items.setEmpr_ubigeo(ConstanteSUNAT.EMPRESA_UBIGEO);
        items.setEmpr_pais(ConstanteSUNAT.EMPRESA_PAIS);
        items.setDocu_enviaws(ConstanteSUNAT.EMPRESA_ENVIA_WS);
        // Cliente o receptor 
        
        items.setClie_tipodoc(cabecera.getTipoDocSunat()); // Sin docu. "-" solo se usa DNI = "1"// anexo de catalogos
        items.setClie_numero(cabecera.getNumeroDocumentoCliente());
        items.setClie_nombre(cabecera.getDenominacionCliente());
        
        
        DecimalFormat df = new DecimalFormat("#.00");
        //documento
        // Cabecera
        items.setDocu_tipodocumento(cabecera.getTipoComprobanteSunat()); // anexo de catalogos 03 refiere a Boleta de Venta Electronica
        items.setDocu_numero(cabecera.getNumeroComprobante()); 
        items.setDocu_fecha(cabecera.getFechaComprobanteTxt()); // formato segun sunat
        
        //System.out.println(df.format(1000.00).replace(",", "."));
        //items.setDocu_gravada(df.format(1000.00).replace(",", "."));
        System.out.println(df.format(cabecera.getTotalGeneral()).replace(",", "."));
        items.setDocu_gravada(df.format(cabecera.getTotalGeneral()).replace(",", "."));
        
        //System.out.println(df.format(180.00).replace(",", "."));
        //items.setDocu_igv(df.format(180.00).replace(",", "."));
        System.out.println(df.format(cabecera.getTotalIgv()).replace(",", "."));
        items.setDocu_igv(df.format(cabecera.getTotalIgv()).replace(",", "."));
        
        items.setDocu_descuento("0.00");
        items.setDocu_exonerada("0.00");
        items.setDocu_gratuita("0.00");
        items.setDocu_inafecta("0.00");
        items.setDocu_isc("0.00");
        items.setDocu_moneda(ConstanteSUNAT.MONEDA_SOLES);
        items.setDocu_otroscargos("0.00");
        items.setDocu_otrostributos("0.00");
        //System.out.println(df.format(1180.00).replace(",", "."));
        //items.setDocu_total(df.format(1180.00).replace(",", "."));
        
        System.out.println(df.format(cabecera.getTotalNeto()).replace(",", "."));
        items.setDocu_total(df.format(cabecera.getTotalNeto()).replace(",", "."));
        
        List<DocumentodetBean> detdocelec = new ArrayList<>();
        
        Iterator<ComprobanteDetalle> it = lDetalle.iterator();
        Integer i=1;
        while (it.hasNext()) {
        	ComprobanteDetalle detalle=it.next();
        	DocumentodetBean detdoc = new DocumentodetBean();
        	detdoc.setDocu_codigo("01");
        	detdoc.setIddetalle(String.valueOf(i++));
        	detdoc.setItem_orden(String.valueOf(i++));
            detdoc.setItem_codproducto(String.valueOf(detalle.getIdServicio()));
            detdoc.setItem_descripcion(detalle.getDenominacionServicio());
            detdoc.setItem_unidad("NIU");
            detdoc.setItem_cantidad(df.format(detalle.getCantidad()).replace(",", "."));
            detdoc.setItem_moneda(ConstanteSUNAT.MONEDA_SOLES);
            detdoc.setItem_pventa(df.format(detalle.getTotalLinea()).replace(",", "."));
            detdoc.setItem_ti_subtotal(df.format(detalle.getSubTotalNeto()).replace(",", "."));
            detdoc.setItem_pventa_no_onerosa("0.00");
            detdoc.setItem_ti_igv(df.format(detalle.getIgv()).replace(",", "."));
            /*
             * obj.setTotalLinea(rs.getDouble("total_general"));
            	obj.setIgv(rs.getDouble("total_igv"));
            	obj.setSubTotalNeto(rs.getDouble("total_gravada"));
             */
            detdoc.setItem_afectacion("10");
            
        	detdocelec.add(detdoc);
        }
        
        Leyenda leyenda = new Leyenda();
        List<Leyenda> leyendas = new ArrayList<>();
        leyenda.setLeyendaCodigo("1000");
        leyenda.setLeyendaTexto(cabecera.getTotalNetoWord());
        leyendas.add(leyenda);
        
        BolElectronicaIng.generarXMLZipiadoBoleta(this.dataDirectory,items, detdocelec, leyendas);
    	return 0;
    }
    
}
